unit MyTypes;

{
    Vector graphical editor.
    Version: 10.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2024  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

{$mode ObjFPC}{$H+}

interface

uses Classes, Graphics;

type
  coord4 = record
    x1,y1,x2,y2 : double;
    id : integer;
    col:Tcolor;
    Width : byte;
    style : TPenStyle;
  end;

type
  coord2 = record
    id : integer;
    x,y:double;
  end;

type
  coord3 = record
    x,y,r:double;
    id : integer;
    col:Tcolor;
    Width : byte;
    style : TPenStyle;
  end;

type
  coord8 = record
    x1,y1,x2,y2 : double;
    l_x,t_y,r_x,b_y : double;
    CentrX, CentrY : double;
    rad : double;
    StartAngle, EndAngle : double;
    id : integer;
    col:Tcolor;
    Width : byte;
    style : TPenStyle;
  end;

type
   text_type = record
     x,y,h:double;
     id : integer;
     col:TColor;
     s:string[50];
   end;

 type
   arrow_type = record
     x,y:double;
     id : integer;
     t:string;
     col:Tcolor;
   end;

 type
   TDimType = record
     //коорд.начала выносных линий
     x1, y1, x2, y2 : double;
     //коорд.конца выносных линий
     x3, y3, x4, y4 : double;
     //Текст
     nadp : double;
     //Координаты центра текста
     nadpCX, nadpCY : double;
     //С какой точностью отображать
     NumDigit : byte;
     //Номер
     id : integer;
   end;

 type
   TBlockType = record
     num : integer;
     id_num : array of array of integer;
   end;

 type
   FreeVal = record
     S,              //Площадь
     L1,             //Периметр
     L2 : Double;    //Изм.длина
   end;

implementation

end.

