unit dimension;

{
    Vector graphical editor.
    Version: 10.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2024  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

//Функции для измерений

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Graphics, Dialogs, Forms, Controls, Drawing_unit;

//Вычисление периметра
function L_contur(x,y : double) : double;
//Вычисление Центра Тяжести
function Coord_CentrT(x,y : double) : MyTPoint;
//Измерение угла
function GetAngle(x,y : double) : double;
//Измерение длины
procedure GetLength(x,y : double);

implementation

uses Unit1, my_modify, math, SpecFunction, View;

//Измерение длины
procedure GetLength(x,y : double);
begin
    near_points(x,y,4);

   //1 координата
   if stad_dim=false then
   begin
     Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую точку';

     x1_dim:=x; y1_dim:=y;

     stad_dim:=true;

     x := x + screen_x;
     y := y + screen_y;

     Form1.WS.Canvas.Pen.Color:=clPurple;
     Form1.WS.Canvas.Ellipse(Round(x)-5,Round(y)+5,
                             Round(x)+5,Round(y)-5);
     Form1.WS.Canvas.Pen.Color:=clBlack;
   end
   //2 координата
   else
   begin
     x2_dim:=x; y2_dim:=y;

     x := x + screen_x;
     y := y + screen_y;

     Form1.WS.Canvas.Pen.Color:=clPurple;
     Form1.WS.Canvas.Ellipse(Round(x)-5,Round(y)+5,
                             Round(x)+5,Round(y)-5);
     Form1.WS.Canvas.Line(Round(x1_dim) + screen_x,
                          Round(y1_dim) + screen_y,
                          Round(x2_dim) + screen_x,
                          Round(y2_dim) + screen_y);

     Form1.WS.Canvas.Font.Size:=12;
     Form1.WS.Canvas.Font.Color:= clPurple;

     Form1.WS.Canvas.TextOut(Round(min(x1_dim,x2_dim)+abs(x2_dim-x1_dim)/2)+ screen_x,
                             Round(min(y1_dim,y2_dim)+abs(y2_dim-y1_dim)/2)+ screen_y -
                             Form1.WS.Canvas.Font.Size,
                             FloatToStr(SimpleRoundTo((sqrt(power((x2_dim-x1_dim),2)+
                                                             power((y2_dim-y1_dim),2)) ),-3)));

     Form1.WS.Canvas.Pen.Color:=clBlack;



     stad_dim:=false;

     Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
   end;
end;

//Измерение угла
function GetAngle(x,y : double) : double;

var
  vector_1, vector_2 : MyTPoint;
  angle_vector : double;

begin
    result := -1;

    if Length(Free_point_ar) = 2 then //3 точка
      begin
         SetLength(Free_point_ar,3);

         near_points(x,y,4);

         Free_point_ar[2].X := X;
         Free_point_ar[2].Y := Y;

         vector_1.X := Free_point_ar[0].X - Free_point_ar[1].X;
         vector_1.Y := Free_point_ar[0].Y - Free_point_ar[1].Y;
         vector_2.X := Free_point_ar[2].X - Free_point_ar[1].X;
         vector_2.Y := Free_point_ar[2].Y - Free_point_ar[1].Y;

         //Расчет угла
         angle_vector := (vector_1.X*vector_2.X+vector_1.Y*vector_2.Y)/
                    (sqrt(power(vector_1.X,2)+power(vector_1.Y,2))*
                     sqrt(power(vector_2.X,2)+power(vector_2.Y,2)));

         angle_vector := RadToDeg(arccos(angle_vector));

         result := angle_vector;

         ///Результат/////////////////////////////////////////////////////////////
         Free_point_ar[0].X += Screen_x;
         Free_point_ar[0].y += Screen_y;
         Free_point_ar[1].X += Screen_x;
         Free_point_ar[1].y += Screen_y;
         Free_point_ar[2].X += Screen_x;
         Free_point_ar[2].y += Screen_y;

         Form1.WS.Canvas.Pen.Color := clPurple;
         //Form1.WS.Canvas.Font.Size:=12;
         Form1.WS.Canvas.Font.Color:= clPurple;

         Form1.WS.Canvas.Line(Round(Free_point_ar[0].X),
                              Round(Free_point_ar[0].Y),
                              Round(Free_point_ar[1].X),
                              Round(Free_point_ar[1].Y));
         Form1.WS.Canvas.Line(Round(Free_point_ar[1].X),
                              Round(Free_point_ar[1].Y),
                              Round(Free_point_ar[2].X),
                              Round(Free_point_ar[2].Y));

         ///
         If (Free_point_ar[0].X > Free_point_ar[1].X) and
            (Free_point_ar[2].X > Free_point_ar[1].X) then Free_point_ar[1].X += 20
         else
         If ((Free_point_ar[0].X > Free_point_ar[1].X) and
            (Free_point_ar[2].X < Free_point_ar[1].X)) or
            ((Free_point_ar[0].X < Free_point_ar[1].X) and
            (Free_point_ar[2].X > Free_point_ar[1].X)) then Free_point_ar[1].X += 0
         else
         Free_point_ar[1].X -= 40;

         ///
         If (Free_point_ar[0].y > Free_point_ar[1].y) and
            (Free_point_ar[2].y > Free_point_ar[1].y) then Free_point_ar[1].y += 20
         else
         If ((Free_point_ar[0].y > Free_point_ar[1].y) and
            (Free_point_ar[2].y < Free_point_ar[1].y)) or
            ((Free_point_ar[0].y < Free_point_ar[1].y) and
            (Free_point_ar[2].y > Free_point_ar[1].y))then Free_point_ar[1].y += 0
         else
         Free_point_ar[1].y -= 40;

         Form1.WS.Canvas.TextOut(Round(Free_point_ar[1].X),
                                 Round(Free_point_ar[1].Y),
                                 FloatToStr(SimpleRoundTo(abs(angle_vector),-3)));

         Showmessage(FloatToStr(abs(angle_vector)));

         SetLength(Free_point_ar,0);
         exit;
      end;

      if Length(Free_point_ar) = 1 then //2 точка
      begin
         near_points(x,y,4);

         SetLength(Free_point_ar,2);
         Free_point_ar[1].X := X;
         Free_point_ar[1].Y := Y;
      end;

      if Length(Free_point_ar) = 0 then //1 точка
      begin
         near_points(x,y,4);

         SetLength(Free_point_ar,1);
         Free_point_ar[0].X := X;
         Free_point_ar[0].Y := Y;
      end;
end;

//Вспомогательная функция для вычисления периметра
function prover_near_pixel (x, y : integer; col : Tcolor) : boolean;
begin
     result := false;
     If (Form1.WS.Canvas.Pixels[x-1,y-1] = col) then result:=true;
     If (Form1.WS.Canvas.Pixels[x,y-1] = col) then result:=true;
     If (Form1.WS.Canvas.Pixels[x+1,y-1] = col) then result:=true;
     If (Form1.WS.Canvas.Pixels[x-1,y] = col) then result:=true;
     If (Form1.WS.Canvas.Pixels[x+1,y] = col) then result:=true;
     If (Form1.WS.Canvas.Pixels[x-1,y+1] = col) then result:=true;
     If (Form1.WS.Canvas.Pixels[x,y+1] = col) then result:=true;
     If (Form1.WS.Canvas.Pixels[x+1,y+1] = col) then result:=true;
end;

//Вычисление периметра (не используется)
function L_contur(x,y : double) : double;

var
    x_per : integer = 0;
    y_per : integer = 0;
    line_color : TColor;
    Length_per : double = 0;
    vrem_color, temp_color: TColor;

begin
   Y+=Screen_y;
   X+=Screen_x;

   for x_per := Round(X) downto 0 do //Идти от точки влево
       begin
           if (Form1.WS.Canvas.Pixels[x_per,Round(Y)] <> clWhite) then break;
           if (x_per = 0) then
           begin
               showmessage('Контур не замкнут');
               Reset_mode;
               result := -1;
               exit;
           end;
       end;
       //Цвет контура
       line_color := Form1.WS.Canvas.Pixels[x_per,Round(Y)];

       y_per := Round(Y);

       temp_color := Form1.WS.Canvas.Brush.Color;
       vrem_color := RGBToColor(200,200,200);
       Form1.WS.Canvas.Brush.Color := vrem_color;
       Form1.WS.Canvas.FloodFill(Round(x),Round(y),line_color,fsBorder);
       Form1.WS.Canvas.Brush.Color := temp_color;

       Form1.WS.Canvas.Pixels[x_per,y_per] := clAqua;

       while (true) do
       begin
           //Вверх
           if (Form1.WS.Canvas.Pixels[x_per,Y_per-1] = line_color) and
              (prover_near_pixel(x_per, y_per-1,vrem_color)) then
           begin
                     Form1.WS.Canvas.Pixels[x_per,y_per] := clAqua;
                     x_per := x_per;
                     y_per := y_per - 1;
                     Length_per += 1;
                     continue;
           end;
           //Вниз
           if (Form1.WS.Canvas.Pixels[x_per,Y_per+1] = line_color) and
              (prover_near_pixel(x_per, y_per+1,vrem_color)) then
           begin
                     Form1.WS.Canvas.Pixels[x_per,y_per] := clAqua;
                     x_per := x_per;
                     y_per := y_per + 1;
                     Length_per += 1;
                     continue;
           end;
           //Влево
           if (Form1.WS.Canvas.Pixels[x_per-1,Y_per] = line_color) and
              (prover_near_pixel(x_per-1, y_per,vrem_color)) then
           begin
                     Form1.WS.Canvas.Pixels[x_per,y_per] := clAqua;
                     x_per := x_per-1;
                     y_per := y_per;
                     Length_per += 1;
                     continue;
           end;
           //Вправо
           if (Form1.WS.Canvas.Pixels[x_per+1,Y_per] = line_color) and
              (prover_near_pixel(x_per+1, y_per,vrem_color)) then
           begin
                     Form1.WS.Canvas.Pixels[x_per,y_per] := clAqua;
                     x_per := x_per+1;
                     y_per := y_per;
                     Length_per += 1;
                     continue;
           end;

           ///////////ДИАГОНАЛИ/////////////////////////////////////////////
           //Вверх влево
           if (Form1.WS.Canvas.Pixels[x_per-1,Y_per-1] = line_color) then
           begin
                     Form1.WS.Canvas.Pixels[x_per,y_per] := clAqua;
                     x_per := x_per - 1;
                     y_per := y_per - 1;
                     Length_per += 1;
                     continue;
           end;
           //Вверх вправо
           if (Form1.WS.Canvas.Pixels[x_per+1,Y_per-1] = line_color) then
           begin
                     Form1.WS.Canvas.Pixels[x_per,y_per] := clAqua;
                     x_per := x_per + 1;
                     y_per := y_per - 1;
                     Length_per += 1;
                     continue;
           end;
           //Вниз влево
           if (Form1.WS.Canvas.Pixels[x_per-1,Y_per+1] = line_color) then
           begin
                     Form1.WS.Canvas.Pixels[x_per,y_per] := clAqua;
                     x_per := x_per - 1;
                     y_per := y_per + 1;
                     Length_per += 1;
                     continue;
           end;
           //Вниз вправо
           if (Form1.WS.Canvas.Pixels[x_per+1,Y_per+1] = line_color) then
           begin
                     Form1.WS.Canvas.Pixels[x_per,y_per] := clAqua;
                     x_per := x_per + 1;
                     y_per := y_per + 1;
                     Length_per += 1;
                     continue;
           end;
           break;
       end;

       Result := Length_per;
end;

//Вычисление Центра Тяжести
function Coord_CentrT(x,y : double) : MyTPoint;

var
  get_p : TColor;
  x_count, y_count : integer;
  counter : real = 0;
  counter2 : integer = 0;
  x_center : double = -1;
  y_center : double = -1;

begin
    Y+=Screen_y;
    X+=Screen_x;

    Clear;

    Form1.WS.Canvas.Brush.Color := clAqua;
    Form1.WS.Canvas.FloodFill(Round(x),Round(y),clBlack,fsBorder);

    for y_count:=ABS(Form1.WS.Top) to ABS(Form1.WS.Top)+Form1.Height do
        for x_count:=ABS(Form1.WS.Left) to ABS(Form1.WS.Left)+Form1.Width do
          begin
              get_p := Form1.WS.Canvas.Pixels[x_count, y_count];
              if get_p = clAqua then counter += 1;
          end;
    counter *= 1.014; //Поправочный коэффициент из-за толщины обводки

    Showmessage('Площадь фигуры равна '+Round(counter).ToString);

    counter2:=0;
    for y_count:=ABS(Form1.WS.Top) to ABS(Form1.WS.Top)+Form1.Height do
        for x_count:=ABS(Form1.WS.Left) to ABS(Form1.WS.Left)+Form1.Width do
          begin
              get_p := Form1.WS.Canvas.Pixels[x_count, y_count];
              if get_p = clAqua then
              begin
                 Form1.WS.Canvas.Pixels[x_count, y_count] := clWhite;
                 counter2 += 1;
                 y_center := y_count; //Координата Y центра тяжести
              end;
              if (Round(counter) div 2) <= counter2 then break;
          end;

    Form1.WS.Canvas.FloodFill(Round(x),Round(y),clBlack,fsBorder);

    counter2 := 0;
    for x_count:=ABS(Form1.WS.Left) to ABS(Form1.WS.Left)+Form1.Width do
        for y_count:=ABS(Form1.WS.Top) to ABS(Form1.WS.Top)+Form1.Height do
          begin
              get_p := Form1.WS.Canvas.Pixels[x_count, y_count];
              if get_p = clAqua then
              begin
                 Form1.WS.Canvas.Pixels[x_count, y_count] := clWhite;
                 counter2 += 1;
                 x_center:=x_count; //Координата X центра тяжести
              end;
              if (Round(counter) div 2) <= counter2 then break;
          end;

     //Построение точки центра тяжести
     points[k_points].x := x_center-Screen_x;
     points[k_points].y := y_center-Screen_y;
     points[k_points].id := id;
     id += 1;

     result.x := points[k_points].x;
     result.y := points[k_points].y;

     k_points+=1;

     Form1.WS.Canvas.Brush.Style := bsClear;

     //Включить отображение точек
     P_show := true;
     Form1.Show_pset.Checked := true;
end;


end.

