unit Intersection_unit;

{
    Vector graphical editor.
    Version: 10.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2024  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

//Функции работы с пересечениями

{$mode ObjFPC}{$H+}

interface

uses Drawing_unit, SpecFunction, Dialogs;

type
  TLineType = record
    x1,y1,x2,y2 : double;
  end;

type
  TCirType = record
    x,y,r : double;
  end;

//Определение пересечения линий
//function intersection(prov:integer):boolean;
//Определение факта пересечения 2 конкретных линий
function intersection(lin1, lin2 : integer):boolean;
// определение круг пересек. линию
procedure intersection_circ_line(prov:integer);
//Линия пересекает окружность
procedure intersection_line_circ(prov:integer);
//Коорд.пересеч. линий
procedure prov_intersect ();
//Пересечение 2 окружностей
procedure intersect_2_cir(x1, y1, r1:double);
//Абстрактная линия пересекает абстрактную окружность
function LineCrosCirc(lin : TLineType;
                      cir : TCirType) : boolean;
//Точка пересечения 2 отрезков
function PointCross2Line(lin1,lin2 : integer; NeedDot : boolean) : MyTPoint;
//Точка пересечения 2 отрезков
function PointCross2Line(x1,y1,x2,y2,x3,y3,x4,y4 : double) : MyTPoint;

implementation
uses
  Graphics,Unit1,Classes, SysUtils, math;

//Старая точка пересечения
//procedure intersect_points(prov:integer);
//
//var
//   m1,m2,b1,b2,
//   x1,x2,y1,y2,
//   x3,x4,y3,y4:double;
//
//begin
//   //Определение точки пересечения
//   m1:=0;
//   m2:=0;
//
//   //Для 1 отрезка
//   x1:=Lines[k].x1; x2:=Lines[k].x2;
//   y1:=Lines[k].y1; y2:=Lines[k].y2;
//   if x1<>x2 then m1:=(y1-y2)/(x1-x2);
//   b1:=y1-m1*x1;
//
//   //Для второго отрезка
//   x3:=Lines[prov].x1; x4:=Lines[prov].x2;
//   y3:=Lines[prov].y1; y4:=Lines[prov].y2;
//
//   If x3<>x4 then m2:=(y3-y4)/(x3-x4);
//   b2:=y3-m2*x3;
//
//   If (m1<>0) and (m2<>0) then            //Обе под углом
//   begin
//       x_cross := (b2-b1) / (m1-m2);
//       y_cross := m1*x_cross+b1;
//   end
//
//    Else    If (x3=x4) and (x1<>x2) then  //вертикаль + наклон
//        begin
//             x_cross:=x3;
//             y_cross:=m1*x3+b1;
//        end
//
//    Else    If (x1=x2) and (x3<>x4) then   //вертикаль + наклон
//        begin
//            x_cross:=x2;
//            y_cross:=m2*x1+b2;
//
//        end
//
//    Else    If (y1=y2) and (y3<>y4) then  //горизонт + наклон
//        begin
//            y_cross:=y1;
//            m2:=(y3-y4)/(x3-x4);
//            b2:=y3-m2*x3;
//            x_cross:=(y_cross-b2)/m2;
//        end
//
//    Else    If (y3=y4) and (y1<>y2) then   //горизонт + наклон
//        begin
//            y_cross:=y3;
//            m1:=(y1-y2)/(x1-x2);
//            b1:=y1-m1*x1;
//            x_cross:=(y_cross-b1)/m1;
//        end
//
//
//   Else If (m1=0) and (x3=x4) then         //ОРТО
//   begin
//        y_cross := y1;
//        x_cross := x3;
//   end
//                                           //ОРТО
//   Else If (m2=0) and (x1=x2) then
//   begin
//        y_cross := y3;
//        x_cross := x1;
//   end;
//end;

//Определение факта пересечения 2 конкретных линий
function intersection(lin1, lin2 : integer):boolean;

var v1,v2,v3,v4:double;

begin
  Result:=false;

  v1:=(Lines[lin2].x2-Lines[lin2].x1)*(Lines[lin1].y1-Lines[lin2].y1)-(Lines[lin2].y2-Lines[lin2].y1)*(Lines[lin1].x1-Lines[lin2].x1);
  v2:=(Lines[lin2].x2-Lines[lin2].x1)*(Lines[lin1].y2-Lines[lin2].y1)-(Lines[lin2].y2-Lines[lin2].y1)*(Lines[lin1].x2-Lines[lin2].x1);
  v3:=(Lines[lin1].x2-Lines[lin1].x1)*(Lines[lin2].y1-Lines[lin1].y1)-(Lines[lin1].y2-Lines[lin1].y1)*(Lines[lin2].x1-Lines[lin1].x1);
  v4:=(Lines[lin1].x2-Lines[lin1].x1)*(Lines[lin2].y2-Lines[lin1].y1)-(Lines[lin1].y2-Lines[lin1].y1)*(Lines[lin2].x2-Lines[lin1].x1);
  If (v1*v2<0) and (v3*v4<0) then Intersection:=true;
end;

//Определение факта пересечения линий (устар.)
//function intersection(prov:integer):boolean;
//
//var v1,v2,v3,v4:double;
//
//begin
//  Result:=false;
//
//  v1:=(Lines[k].x2-Lines[k].x1)*(Lines[prov].y1-Lines[k].y1)-(Lines[k].y2-Lines[k].y1)*(Lines[prov].x1-Lines[k].x1);
//  v2:=(Lines[k].x2-Lines[k].x1)*(Lines[prov].y2-Lines[k].y1)-(Lines[k].y2-Lines[k].y1)*(Lines[prov].x2-Lines[k].x1);
//  v3:=(Lines[prov].x2-Lines[prov].x1)*(Lines[k].y1-Lines[prov].y1)-(Lines[prov].y2-Lines[prov].y1)*(Lines[k].x1-Lines[prov].x1);
//  v4:=(Lines[prov].x2-Lines[prov].x1)*(Lines[k].y2-Lines[prov].y1)-(Lines[prov].y2-Lines[prov].y1)*(Lines[k].x2-Lines[prov].x1);
//  If (v1*v2<0) and (v3*v4<0) then Intersection:=true;
//end;

procedure prov_intersect (); //Создание точек пересечения

var
  prov:integer;

begin
      //проверка пересечений линий
        for prov:=0 to k-1 do
        if intersection(prov,k)=true then
         begin
             ////Определение координат точки пересечения
             //intersect_points(prov);
             PointCross2Line(prov,k, true);
         end;
end;

procedure draw_cross_circ_line(cros,c_num, //Окружность пересекает отрезки
                   l_num:integer);

var
  k_cross,D, B_cross,
  x_p_1,y_p_1,x_p_2,y_p_2,
  a,b,c : double;

begin
    //Уравнение линии
    if (lines[l_num].x2-lines[l_num].x1)<>0 then //если не верт.линия
    begin
          k_cross:=(lines[l_num].y2-lines[l_num].y1)/(lines[l_num].x2-lines[l_num].x1);
          B_cross:=lines[l_num].y1 - k_cross*lines[l_num].x1;

          a := 1 + power(k_cross,2);//
          b := 2*k_cross*B_cross-2*k_cross*Circles[c_num].y-
                                           2*Circles[c_num].x;//
          c := Power((B_cross-Circles[c_num].y),2)+
               Power(Circles[c_num].x,2)-Power(Circles[c_num].r,2);//

          if cros=1 then //Пересечение
          begin
           D := (power(b,2) - 4*a*c);

           x_p_1 := (-b-sqrt(D))/(2*a);
           y_p_1 := k_cross*x_p_1+B_cross;
           x_p_2 := (-b+sqrt(D))/(2*a);
           y_p_2 := k_cross*x_p_2+B_cross;

           //Проверка на принадлежность точки отрезку
           if (x_p_1>lines[l_num].x1) and (x_p_1<lines[l_num].x2) or
              (x_p_1>lines[l_num].x2) and (x_p_1<lines[l_num].x1)
              then
               begin
                 Points[k_points].x:=x_p_1; Points[k_points].y:=y_p_1;
                 id += 1;
                 k_points+=1;
               end;
           //Проверка на принадлежность точки отрезку
           if (x_p_2>lines[l_num].x1) and (x_p_2<lines[l_num].x2) or
              (x_p_2>lines[l_num].x2) and (x_p_2<lines[l_num].x1)
              then
               begin
                 Points[k_points].x:=x_p_2; Points[k_points].y:=y_p_2;
                 Points[k_points].id := id;
                 id += 1;
               end;

          end;

          if cros=2 then //Касание
          begin
              x_p_1 := -b/(2*a);
              y_p_1 := k_cross*x_p_1+B_cross;
              //Проверка на принадлежность точки отрезку
              if (x_p_1>lines[l_num].x1) and (x_p_1<lines[l_num].x2) or
                (x_p_1>lines[l_num].x2) and (x_p_1<lines[l_num].x1)
                then
                begin
                    Points[k_points].x:=x_p_1; Points[k_points].y:=y_p_1;
                    Points[k_points].id := id;
                    id += 1;
                    k_points+=1;
                end;
          end;
    end;
    if (lines[l_num].x2-lines[l_num].x1)=0 then //если вертикаль
    begin
        if cros=1 then //2 точки
        begin
            x_p_1:=lines[l_num].x1;
            y_p_1:=Circles[c_num].y-sqrt(abs(Power(Circles[c_num].r,2)-
            power(abs(x_p_1-Circles[c_num].x),2)));
            y_p_2:=Circles[c_num].y+sqrt(abs(Power(Circles[c_num].r,2)-
            power(abs(x_p_1-Circles[c_num].x),2)))
            ;
            //Проверка на принадлежность первой точки отрезку
            if (y_p_1>lines[l_num].y1) and (y_p_1<lines[l_num].y2) or
              (y_p_1>lines[l_num].y2) and (y_p_1<lines[l_num].y1)
              then
               begin
                  Points[k_points].x:=x_p_1; Points[k_points].y:=y_p_1;
                  Points[k_points].id := id;
                  id+=1;
                  k_points+=1;
               end;
            //Проверка на принадлежность второй точки отрезку
            if (y_p_2>lines[l_num].y1) and (y_p_2<lines[l_num].y2) or
               (y_p_2>lines[l_num].y2) and (y_p_2<lines[l_num].y1)
              then
               begin
                  x_p_2:=lines[l_num].x2;
                  y_p_2:=Circles[c_num].y+sqrt(abs(Power(Circles[c_num].r,2)-
                  power(abs(x_p_2-Circles[c_num].x),2)));
                  Points[k_points].x:=x_p_2; Points[k_points].y:=y_p_2;
                  Points[k_points].id := id;
                  id += 1;
                  k_points+=1;
               end;
        end;
    end;
end;

procedure intersection_circ_line // определение круг пересек. линию
              (prov:integer);

var
   i_cross:integer;
   x_c,y_c,r_c,
   a,b,c,p,h:double;
   //alpha,beta,gamma:double;

begin
    x_c:=circles[prov].x;
    y_c:=circles[prov].y;
    r_c:=circles[prov].r;


    for i_cross:=0 to k-1 do
    begin
        a:=sqrt(sqr(abs(Lines[i_cross].x2-Lines[i_cross].x1))+
                          sqr(abs(Lines[i_cross].y2-Lines[i_cross].y1)));

        b:=sqrt(sqr(abs(x_c-Lines[i_cross].x1))+
                          sqr(abs(y_c-Lines[i_cross].y1)));

        c:=sqrt(sqr(abs(x_c-Lines[i_cross].x2))+
                          sqr(abs(y_c-Lines[i_cross].y2)));

        p:=(a+b+c)/2;

     if (a=0) or (b=0) or (c=0) then continue;

     h:=2*sqrt(p*abs(p-a)*abs(p-b)*abs(p-c))/a;

     if (h<r_c)then //Пересечение (2 точки)
      begin
          draw_cross_circ_line(1,prov,i_cross);//Определение точек пересеч.
      end;
     if (h=r_c)then  //Касание (1 точка)
      begin
          draw_cross_circ_line(2,prov,i_cross);//Определение точек пересеч.
      end;
    end;
end;

//Проверка, лжеит ли точка на верт.линии
function PointOnVertLine(NumLine : integer; y : double) : boolean;
begin
    result := true;
    if ((lines[NumLine].y1 > y) and
      (lines[NumLine].y2 > y)) or
      ((lines[NumLine].y1 < y) and
      (lines[NumLine].y2 < y)) then result := false;
end;

procedure draw_cross_line_circ(cros,l_num, //Линия пересекает окружность
                   c_num:integer);

var
  k_cross,D, B_cross,
  x_p_1,y_p_1,x_p_2,y_p_2,
  a,b,c : double;

begin
    //Уравнение линии
    If (lines[l_num].x2-lines[l_num].x1)<>0 then //если не верт.линия
    begin
        k_cross:=(lines[l_num].y2-lines[l_num].y1)/(lines[l_num].x2-lines[l_num].x1);
        B_cross:=lines[l_num].y1 - k_cross*lines[l_num].x1;

        a := 1 + power(k_cross,2);//
        b := 2*k_cross*B_cross-2*k_cross*Circles[c_num].y-
                                         2*Circles[c_num].x;//
        c := Power((B_cross-Circles[c_num].y),2)+
             Power(Circles[c_num].x,2)-Power(Circles[c_num].r,2);//

        if cros=1 then //Пересечение
        begin
         D := (power(b,2) - 4*a*c);

         x_p_1 := (-b-sqrt(D))/(2*a);
         x_p_2 := (-b+sqrt(D))/(2*a);

         y_p_1 := k_cross*x_p_1+B_cross;
         y_p_2 := k_cross*x_p_2+B_cross;

         If ((x_p_1>lines[l_num].x1) and (x_p_1<lines[l_num].x2)) or
            ((x_p_1>lines[l_num].x2) and (x_p_1<lines[l_num].x1)) then
         begin
             Points[k_points].x:=x_p_1; Points[k_points].y:=y_p_1;
             Points[k_points].id := id;
             id += 1;
             k_points+=1;
         end;

         If ((x_p_2>lines[l_num].x1) and (x_p_2<lines[l_num].x2)) or
            ((x_p_2>lines[l_num].x2) and (x_p_2<lines[l_num].x1)) then
         begin
             Points[k_points].x:=x_p_2; Points[k_points].y:=y_p_2;
             Points[k_points].id := id;
             id += 1;
             k_points+=1;
         end;
        end;
        if cros=2 then //Касание
        begin
            x_p_1 := -b/(2*a);
            y_p_1 := k_cross*x_p_1+B_cross;
            Points[k_points].x:=x_p_1; Points[k_points].y:=y_p_1;
            Points[k_points].id := id;
            id += 1;
            k_points+=1;
        end;
    end;
    If (lines[l_num].x2-lines[l_num].x1)=0 then //если верт.линия
    begin
        if cros=1 then  //2 точки
        begin
            x_p_1:=lines[l_num].x1;
            y_p_1:=Circles[c_num].y-sqrt(abs(Power(Circles[c_num].r,2)-
                   power(abs(x_p_1-Circles[c_num].x),2)));

            //Ложное пересечение////////////////////////////////////////
            if (PointOnVertLine(l_num,y_p_1)) then
            begin
                Points[k_points].x:=x_p_1; Points[k_points].y:=y_p_1;
                Points[k_points].id := id;
                id += 1;
                k_points+=1;
            end;

            x_p_2:=lines[l_num].x2;
            y_p_2:=Circles[c_num].y+sqrt(abs(Power(Circles[c_num].r,2)-
                   power(abs(x_p_2-Circles[c_num].x),2)));
            if (PointOnVertLine(l_num,y_p_2)) then
            begin
                Points[k_points].x:=x_p_2; Points[k_points].y:=y_p_2;
                Points[k_points].id := id;
                id += 1;
                k_points+=1;
            end;

        end;
    end;
    //Clear();
end;

function LineCrosCirc(lin : TLineType; //Абстрактная линия пересекает абстрактную окружность
                      cir : TCirType) : boolean;  //Для выделения рамкой

var
  dist1, dist2 : double;
  //dist3, P, S, h : double;

begin
    //Недоделано. Можно дописать выделение рамкой окружности, когда
    //сторона рамки пересекает окружность, а конечные точки стороны рамки лежат снаружи.

    result := false;

    dist1 := sqrt((sqr(lin.x1-cir.x)+sqr(lin.y1-cir.y)));   //дистация от 1 конца отрезка до центра окружности
    dist2 := sqrt((sqr(lin.x2-cir.x)+sqr(lin.y2-cir.y)));   //дистация от 2 конца отрезка до центра окружности
    //dist3 := sqrt((sqr(lin.x2-lin.x1)+sqr(lin.y1-lin.y2))); //дистация от 1 2 конца отрезка

    if ((dist1 < cir.r) and   //отрезок пересекает окружность
       (dist2 > cir.r)) or
       ((dist1 > cir.r) and   //отрезок пересекает окружность
       (dist2 < cir.r))
       then
    begin
        result := true;
        exit;
    end;

    if (dist1 < cir.r) and   //оба конца внутри окружности
       (dist2 < cir.r) then
    begin
        result := false;
        exit;
    end;
end;

procedure intersection_line_circ  // определение линия пересекает круг
              (prov:integer);

var
   i_cross:integer;
   x_c,y_c,r_c,
   a,b,c,p,h : double;
   //alpha,beta,gamma:double;

begin
    for i_cross:=0 to k_cir-1 do
    begin
      x_c:=circles[i_cross].x;
      y_c:=circles[i_cross].y;
      r_c:=circles[i_cross].r;

      a:=sqrt(sqr(abs(Lines[prov].x2-Lines[prov].x1))+
                          sqr(abs(Lines[prov].y2-Lines[prov].y1)));

      b:=sqrt(sqr(abs(x_c-Lines[prov].x1))+
                          sqr(abs(y_c-Lines[prov].y1)));

      c:=sqrt(sqr(abs(x_c-Lines[prov].x2))+
                          sqr(abs(y_c-Lines[prov].y2)));

      p:=(a+b+c)/2;

      if (a=0) or (b=0) or (c=0) then continue;

      h:=2*sqrt(p*abs(p-a)*abs(p-b)*abs(p-c))/a;

      if (h<r_c)then //Пересечение (2 точки)
      begin
          draw_cross_line_circ(1,prov,i_cross);//Определение точек пересеч.
      end;
      if (h=r_c)then  //Касание (1 точка)
      begin
          draw_cross_line_circ(2,prov,i_cross);//Определение точек пересеч.
      end;
    end;
end;


procedure intersect_2_cir(x1, y1, r1:double);//Точки пересечения окружностей

var
  L, t, xc, yc, vt,
  x2,y2,r2,
  xa, ya, xb, yb : double;
  count:integer;

begin
  for count:=0 to k_cir-2 do
  begin
  x2:=Circles[count].x;
  y2:=Circles[count].y;
  r2:=Circles[count].r;
  try
    L := sqr(x1 - x2) + sqr(y1 - y2);
    vt := sqr(r1 + r2);

    if (L <= vt) and ((sqrt(L)+r2)>r1) and ((sqrt(L)+r1)>r2) then
    begin
        xc := 1 / (2 * l);
        t := (l - sqr(r2) + sqr(r1)) * xc;
        l := sqrt(abs(((vt - l) * (l - sqr(r1 - r2))))) * xc;
        xc := (x2 - x1) * t + x1;
        yc := (y2 - y1) * t + y1;
        t := (y2 - y1) * l;
        xa := xc + t;
        xb := xc - t;
        t := (x1 - x2) * l;
        ya := yc + t;
        yb := yc - t;

        Points[k_points].x:=xa;
        Points[k_points].y:=ya;
        Points[k_points].id := id;
        id += 1;
        k_points+=1;
        Points[k_points].x:=xb;
        Points[k_points].y:=yb;
        Points[k_points].id := id;
        id += 1;
        k_points+=1;
    end;
  finally
  end;

  end;
end;

//Точка пересечения 2 отрезков (нов.)
function PointCross2Line(lin1,lin2 : integer; NeedDot : boolean) : MyTPoint;

var
  x1,y1,x2,y2 : double;
  x3,y3,x4,y4 : double;
  a1,b1,c1,
  a2,b2,c2 : double;
  sov_points : boolean = false;
  n : integer;

begin
    result.x := -1;
    result.y := -1;

    x1 := lines[lin1].x1;
    y1 := lines[lin1].y1;
    x2 := lines[lin1].x2;
    y2 := lines[lin1].y2;

    x3 := lines[lin2].x1;
    y3 := lines[lin2].y1;
    x4 := lines[lin2].x2;
    y4 := lines[lin2].y2;

    a1 := y2 - y1;
    b1 := x1 - x2;
    c1 := y1*x2 - x1*y2;

    a2 := y4 - y3;
    b2 := x3 - x4;
    c2 := y3*x4 - x3*y4;

    if (a1*b2 - b1*a2 = 0) or
       (a1*b2 - b1*a2 = 0) then
       begin
           ShowMessage('Отрезки параллельны');
           Reset_mode;
           exit;
       end;

    result.x := -(c1*b2 - b1*c2)/(a1*b2 - b1*a2);
    result.y := -(a1*c2 - c1*a2)/(a1*b2 - b1*a2);

    if not NeedDot then exit;

    //Если точки еще нет в массиве
     sov_points:=false;
     For n:=0 to k_points do
     begin
         if (abs(points[n].x-result.x)<=1) and
            (abs(points[n].y-result.y)<=1) then
            sov_points:=true;
     end;

     if not sov_points then  //Добавить в массив
     begin
         points[k_points].x:=result.x;
         points[k_points].y:=result.y;
         points[k_points].id := id;
         id += 1;
         k_points+=1;
     end;
end;


//Точка пересечения 2 отрезков (нов.)
function PointCross2Line(x1,y1,x2,y2,x3,y3,x4,y4 : double) : MyTPoint;

var
  a1,b1,c1,
  a2,b2,c2 : double;

begin
    result.x := -1;
    result.y := -1;

    a1 := y2 - y1;
    b1 := x1 - x2;
    c1 := y1*x2 - x1*y2;

    a2 := y4 - y3;
    b2 := x3 - x4;
    c2 := y3*x4 - x3*y4;


    result.x := -(c1*b2 - b1*c2)/(a1*b2 - b1*a2);
    result.y := -(a1*c2 - c1*a2)/(a1*b2 - b1*a2);
end;



end.
