unit LineProp;

{
    Vector graphical editor.
    Version: 10.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2024  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

//Настройка свойств пера

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TLine_prop }

  TLine_prop = class(TForm)
    Ok_button : TButton;
    Cancel_button : TButton;
    ComboBox1 : TComboBox;
    ComboBox2 : TComboBox;
    Label1 : TLabel;
    Label2 : TLabel;
    procedure Ok_buttonClick(Sender : TObject);
    procedure Cancel_buttonClick(Sender : TObject);
  private

  public

  end;

var
  Line_prop : TLine_prop;

implementation
uses Unit1;

{$R *.lfm}

{ TLine_prop }

procedure TLine_prop.Cancel_buttonClick(Sender : TObject);
begin
  Line_prop.ModalResult:=mrCancel;
end;

procedure TLine_prop.Ok_buttonClick(Sender : TObject);
begin
  LineWeight:=StrToInt(Combobox1.Text);

  case Combobox2.ItemIndex of
  0:   LineStyle:=psSolid;
  1:   LineStyle:=psDash;
  2:   LineStyle:=psDot;
  3:   LineStyle:=psDashDot;
  4:   LineStyle:=psDashDotDot;
  end;

  Line_prop.ModalResult:=mrCancel;

end;

end.

