unit Unit1;

{
    Vector graphical editor.
    Version: 10.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2024  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Menus, ComCtrls, ClipBrd, math, LCLIntf, Unit2, Unit3, Unit4, Unit5, Unit6,
  My_Modify, View, Intersection_unit, Load_Save, Drawing_Unit, Lineprop,
  Dimension, block, primitives, LCLType, Buttons, ComboEx, CheckBoxThemed,
  SpecFunction, Calc, MyTypes;

procedure SaveVector;

type
  { TForm1 }

  TForm1 = class(TForm)
    BevelBut : TImage;
    SaveScriptDialog : TSaveDialog;
    SelectChoiceMenu : TCheckGroup;
    Separator14 : TMenuItem;
    Separator15 : TMenuItem;
    SnapCheck : TMenuItem;
    mirButton : TImage;
    DelBut : TImage;
    FilletBut : TImage;
    BevelPanel : TPanel;
    EditPanel : TPanel;
    CopyBut : TImage;
    EditPanel2 : TPanel;
    Divide2 : TImage;
    DrawBevel : TMenuItem;
    Mirror_menu : TMenuItem;
    Panel2 : TPanel;
    RoundEdgeMenu : TMenuItem;
    MultiSelBut : TImage;
    RotateBut : TImage;
    MoveBut : TImage;
    Separator7 : TMenuItem;
    TrimBut : TImage;
    SelByFrameBut : TImage;
    EditBut : TImage;
    SelectPanel : TPanel;
    DimPanel : TPanel;
    SelBut : TImage;
    RotDimBut : TImage;
    OrtoDimBut : TImage;
    OrtoDimSelect : TMenuItem;
    NaprPanel : TPanel;
    BlockPanel : TPanel;
    HorNaprBut : TImage;
    AngleNaprBut : TImage;
    DotOnExtCross : TImage;
    DotCrossBut : TImage;
    DotBut : TImage;
    MakeBlockBut : TImage;
    Splitter1 : TSplitter;
    Splitter2 : TSplitter;
    Splitter3 : TSplitter;
    TwoDotsNapr : TImage;
    Draw_napr_angle : TMenuItem;
    Draw_napr_2point : TMenuItem;
    MenuItem7 : TMenuItem;
    Draw_hor_napr : TMenuItem;
    Draw_vert_napr : TMenuItem;
    VertNaprBut : TImage;
    PointCrossStretched : TMenuItem;
    Dots : TMenuItem;
    Pset : TMenuItem;
    MidDotBut : TImage;
    DotPanel : TPanel;
    Cross_Point : TMenuItem;
    measure: TMenuItem;
    Dr_line_pointss: TMenuItem;
    RectCoord : TImage;
    CircOrdBut : TImage;
    InPoligon : TImage;
    DimBut : TMenuItem;
    ArcBut : TImage;
    LineDim : TMenuItem;
    OutPoligon : TImage;
    Circ3AngleBut : TImage;
    RectBut : TImage;
    LineBut : TImage;
    LineCoordBut : TImage;
    MainMenu1: TMainMenu;
    AllKrug: TMenuItem;
    div_2: TMenuItem;
    Dr_Rect: TMenuItem;
    Copy_but: TMenuItem;
    add_back: TMenuItem;
    Clear_podl: TMenuItem;
    Help_but: TMenuItem;
    Arr_left: TMenuItem;
    Ar_up: TMenuItem;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    Dimension: TMenuItem;
    Area : TMenuItem;
    Get_Angle : TMenuItem;
    Change_line_style : TMenuItem;
    Get_Centr_Mass : TMenuItem;
    Arc_button : TMenuItem;
    Draw_block : TMenuItem;
    Break_block : TMenuItem;
    Circle2Point : TMenuItem;
    Krug : TMenuItem;
    Circle_3Points : TMenuItem;
    CopyToRastrBuffer : TMenuItem;
    MenuItem3 : TMenuItem;
    InMultiAngle : TMenuItem;
    ChangeLength : TMenuItem;
    ButtonPanel : TPanel;
    LinePanel : TPanel;
    CircBut : TImage;
    RectPanel : TPanel;
    CircPanel : TPanel;
    Stretch_trim : TMenuItem;
    ShHelp : TMenuItem;
    OutMultiAngle : TMenuItem;
    Separator12 : TMenuItem;
    DestroyBlockBut : TImage;
    Vibor : TMenuItem;
    MenuItem6 : TMenuItem;
    Sel_all : TMenuItem;
    FrameSelect : TMenuItem;
    Vibir : TMenuItem;
    Need_intersect_point : TMenuItem;
    Separator11 : TMenuItem;
    Size_draft : TMenuItem;
    Save_as_menu : TMenuItem;
    Paral_napr : TMenuItem;
    Scroll_h : TScrollBar;
    Scroll_v : TScrollBar;
    Separator10 : TMenuItem;
    Separator5 : TMenuItem;
    Separator6 : TMenuItem;
    Separator8 : TMenuItem;
    Separator9 : TMenuItem;
    Shift_X : TMenuItem;
    Shift_Y : TMenuItem;
    Save_Script: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    Edit: TMenuItem;
    Re_paint: TMenuItem;
    One_to_Two: TMenuItem;
    Separator1 : TMenuItem;
    Separator2 : TMenuItem;
    Separator3 : TMenuItem;
    Separator4 : TMenuItem;
    Show_back_but: TMenuItem;
    Clear_all: TMenuItem;
    L_vector: TMenuItem;
    Delete_Obj: TMenuItem;
    Cut_but: TMenuItem;
    Arr_right: TMenuItem;
    Ar_down: TMenuItem;
    Rot_sel: TMenuItem;
    Modify: TMenuItem;
    back: TMenuItem;
    Start_timer_delay : TTimer;
    Menu_AddText: TMenuItem;
    Rectangle_coord: TMenuItem;
    ORTO: TMenuItem;
    Show_pset: TMenuItem;
    Select_color: TMenuItem;
    Add_Vector: TMenuItem;
    Show_pointss: TMenuItem;
    S_rastr: TMenuItem;
    S_vector: TMenuItem;
    Draw_line: TMenuItem;
    Dr_line_coord: TMenuItem;
    OpenDialog1: TOpenDialog;
    ColorDialog1: TColorDialog;
    SaveDialog1: TSaveDialog;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    WS: TPaintBox;
    procedure add_backClick(Sender: TObject);
    procedure Arc_buttonClick(Sender : TObject);
    procedure AreaClick(Sender : TObject);
    procedure Arr_rightClick(Sender: TObject);
    procedure Ar_downClick(Sender: TObject);
    procedure Ar_upClick(Sender: TObject);
    procedure backClick(Sender: TObject);
    procedure ChangeLengthClick(Sender : TObject);
    procedure Change_line_styleClick(Sender : TObject);
    procedure Circle2PointClick(Sender : TObject);
    procedure Circle_3PointsClick(Sender : TObject);
    procedure CircPanelClick(Sender : TObject);
    procedure Clear_podlClick(Sender: TObject);
    procedure Copy_butClick(Sender: TObject);
    procedure Cross_PointClick(Sender : TObject);
    procedure Cut_butClick(Sender: TObject);
    procedure Delete_ObjClick(Sender: TObject);
    procedure DimensionClick(Sender: TObject);
    procedure DrawBevelClick(Sender : TObject);
    procedure Draw_blockClick(Sender : TObject);
    procedure Draw_lineClick(Sender: TObject);
    procedure Draw_napr_2pointClick(Sender : TObject);
    procedure Draw_napr_angleClick(Sender : TObject);
    procedure Draw_vert_naprClick(Sender : TObject);
    procedure Dr_line_coordClick(Sender: TObject);
    procedure Dr_RectClick(Sender: TObject);
    procedure FormCloseQuery(Sender : TObject; var CanClose : Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender : TObject);
    procedure FormWindowStateChange(Sender : TObject);
    procedure Get_AngleClick(Sender : TObject);
    procedure Get_Centr_MassClick(Sender : TObject);
    procedure Add_VectorClick(Sender: TObject);
    procedure Div_2Click(Sender: TObject);
    procedure Clear_allClick(Sender: TObject);
    procedure KrugClick(Sender : TObject);
    procedure LineDimClick(Sender : TObject);
    procedure Mirror_menuClick(Sender : TObject);
    procedure OrtoDimSelectClick(Sender : TObject);
    procedure PointCrossStretchedClick(Sender : TObject);
    procedure PsetClick(Sender : TObject);
    procedure RoundEdgeMenuClick(Sender : TObject);
    procedure Stretch_trimClick(Sender : TObject);
    procedure OutMultiAngleClick(Sender : TObject);
    procedure L_vectorClick(Sender: TObject);
    procedure Help_butClick(Sender: TObject);
    procedure Arr_leftClick(Sender: TObject);
    procedure Draw_hor_naprClick(Sender : TObject);
    procedure Break_blockClick(Sender : TObject);
    procedure FrameSelectClick(Sender : TObject);
    procedure CopyToRastrBufferClick(Sender : TObject);
    procedure Multy_Select_butttonClick(Sender : TObject);
    procedure InMultiAngleClick(Sender : TObject);
    procedure Paral_naprClick(Sender : TObject);
    procedure PerimetrClick(Sender : TObject);
    procedure Save_as_menuClick(Sender : TObject);
    procedure Scroll_hChange(Sender : TObject);
    procedure Scroll_vChange(Sender : TObject);
    procedure ShHelpClick(Sender : TObject);
    procedure Shift_XClick(Sender : TObject);
    procedure Shift_YClick(Sender : TObject);
    procedure Menu_AddTextClick(Sender: TObject);
    procedure ModifyClick(Sender: TObject);
    procedure One_to_TwoClick(Sender: TObject);
    procedure ORTOClick(Sender: TObject);
    procedure Rectangle_coordClick(Sender: TObject);
    procedure Re_paintClick(Sender: TObject);
    procedure Rot_selClick(Sender: TObject);
    procedure Select_colorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Sel_allClick(Sender: TObject);
    procedure Show_back_butClick(Sender: TObject);
    procedure Show_psetClick(Sender: TObject);
    procedure Size_draftClick(Sender : TObject);
    procedure S_rastrClick(Sender: TObject);
    procedure Start_timer_delayTimer(Sender : TObject);
    procedure S_vectorClick(Sender : TObject);
    procedure ViborClick(Sender: TObject);
    procedure WSClick(Sender : TObject);
    procedure WSMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WSMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure WSPaint(Sender: TObject);
    procedure Save_ScriptClick(Sender: TObject);
  private

  public

  end;



var
  Form1: TForm1;

  f_name:string;

  Pic:TBitmap;//Временная переменная для Bitmap картинок.

  Back_png:TPortableNetworkGraphic; //Переменная для PNG
  Save_png:TPortableNetworkGraphic; //Временная переменная для сохр.растров. PNG

  podl:boolean = false;//наличие подложки

  arr_length:integer = 10000;//Кол-во элементов

  lines: array of coord4;
  circles: array of coord3;
  arcs : array of coord8;
  points: array of coord2;
  nadp: array of text_type;
  arrow: array of arrow_type;
  blocks : array of TBlockType;
  DimAr : array of TDimType;     //Массив для размеров

  lines_vrem: array of coord4; //Временные массивы для отмены команды
  circles_vrem: array of coord3;
  arcs_vrem : array of coord8;
  points_vrem: array of coord2;
  nadp_vrem: array of text_type;
  arrow_vrem: array of arrow_type;
  DimAr_vrem : array of TDimType;   //Массив для размеров

  k:integer = 0;
  k_cir:integer = 0;
  k_arc:integer = 0;
  k_points:integer = 0;
  k_nadp:integer = 0;
  k_arrow:integer = 0;

  k_vrem:integer = 0; //Временные счетчики для отмены команды
  k_cir_vrem:integer = 0;
  k_arc_vrem:integer = 0;
  k_points_vrem:integer = 0;
  k_nadp_vrem:integer = 0;
  k_arrow_vrem:integer = 0;
  //k_blocks_vrem : integer = 0;

  stad : boolean = false;
  stad_cir : boolean = false;//стадия рисования окружности
  stad_cir3 : byte = 0;//стадия рисования окружности по 3 точкам
  stad_copy : boolean =false;

  contin_line : boolean = true; //Продолжать ли каждый раз линию
  last_point : MyTPoint;

  cross:boolean = false;

  vr1,vr2:real;

  selected:integer = 10000;
  select_type:integer;
  copy_mode:boolean = false;
  cut_mode:boolean = false;

  modyfy:integer;

  Cvet:TColor;

  x_cross:double;
  y_cross:double;

  x_copy,y_copy:double;
  delta_x,delta_y:double;
  delta_x_copy,delta_y_copy:double;

  P_show:boolean = true;
  orto_graph:boolean = false;

  select_mode:boolean = false; //Режим выделения по умолчанию
  multy_select_mode:boolean = false; //Режим множественного выделения
  FrameSelect_mode:boolean = false; //Режим выбора рамкой
  SelAllMode : boolean = false; //Режим выделить все

  drag_point_mode:boolean = false;//Режим перемещения за ключевые точки

  draw_line_mode:boolean = false;
  draw_line_coord_mode:boolean = false;
  draw_circle_mode:boolean = false;
  draw_circle2point_mode:boolean = false;
  draw_circle3points_mode:boolean = false; //Окружность, вписанная в треугольник
  draw_arc_mode:boolean = false;
  draw_points_mode:boolean = false;
  draw_rectangle_mode:boolean = false;
  Draw_MultiAngleMode : boolean = false;//Вписаный многоугольник
  Draw_MultiAngleOutMode : boolean = false;//Описанный многоугольник
  text_input_mode:boolean = false;
  draw_arrow_mode:boolean = false; //Режим рисования стрелок
  drawDimensionMode: Boolean = false;//Режим добавления размеров

  Hor_napr_mode : boolean = false;   //Горизонтальный луч
  Vert_napr_mode : boolean = false; //Вертикальный луч
  Angle_napr_mode : boolean = false; //Луч под углом
  Two_point_napr_mode : boolean = false; //Луч через 2 точки
  Par_shift_mode : boolean = false; //Параллельная прямая

  get_dim_mode:boolean = false;//Режим измерения
  get_angle_mode : boolean = false; //Режим измерения углов
  get_centr_mass_mode : boolean = false;//Находение центра тяжести
  get_perimetr_mode : boolean = false;//Подсчет периметра
  get_area_mode : boolean = false; //Измерение площади с обходом точек

  RotMode : boolean = false;//Режим поворота объектов
  MirMode : boolean = false;//Режим зеркального отражения

  RoundMode : boolean = false;//Режим скругления 2 отрезков

  OrtoDim : boolean = false;

  rect_mode:boolean = false;
  x_rect,y_rect:double;

  loc:string;//путь к файлу подложки

  arrow_kind:string;

  start_prog:boolean = true;//для белой канвы WS
  Show_back:boolean = true; //Показывать подложку

  NeedHelp : boolean = true;

  stad_dim:boolean = false;//№ точки при измерении расстояния
  x1_dim,x2_dim,y1_dim,y2_dim:double; //Координаты измерения
  dim_val:real; //Измеренное число

  d_length:integer;//Относительный размер для линии или окружности
  x_glob,y_glob:double;//Координаты указателя мыши

  //stad_cir:boolean; //стадия рисования окружности

  point_list : array of MyTPoint; //Массив точек для вычисления площади

  sel_1, sel_2 : integer;

  Two_point_ar : array of MyTPoint;
  Free_point_ar : array of MyTPoint;

  LineStyle : TPenStyle = psSolid;
  LineWeight : byte = 1;

  multy_selected_line : array of integer;
  multy_selected_circle : array of integer;
  multy_selected_arcs : array of integer;
  multy_selected_point : array of integer;
  multy_selected_text : array of integer;
  multy_selected_arrow : array of integer;
  multy_selected_dim : array of integer;

  //Для рисования дуги
  Point1, Point2, Point3 : MyTPoint;

  Drag_Point : MyTPoint; //Точка для перемещения
  Drag_selected : integer; //Номер объекта для перетаскивания за точки
  movedPoint : byte; //Номер точки размера для перетаскивания за точки


  Screen_x : integer = 0;//Сдвиг рабочего поля
  Screen_y : integer = 0;

  World_size_h : integer = 4000;
  World_size_v : integer = 4000;

  imgTemp : TPortableNetworkGraphic;

  my : TFormatSettings;

  id : integer = 0;

  vremShowPset : boolean;

  NeedSave : boolean = false;

implementation

{$R *.lfm}

{ TForm1 }


procedure TForm1.WSMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var
  x_vrem, y_vrem : double;

  S_area : double = 0; //площадь
  Lper : double = 0;   //периметр
  Lway : double = 0;   //измеренная длина

  vrem : string = '';
  vrem_angle : double = 0;

  shift_vrem : string;
  shift_size : real = 0;
  angle_line : real = 0;

  //Переменная для создания
  //параллельной
  vremD  : double = 0; //прямой


begin
  x_vrem := double(x);
  y_vrem := double(y);

  x_vrem:=x_vrem-Screen_x;
  y_vrem:=y_vrem-Screen_y;

  //Для зеркального отражения
  if (MirMode) then
  begin
     select_mode := false; //Режим выделения по умолчанию
     multy_select_mode := false; //Режим множеств. выделения
     FrameSelect_mode := false; //Режим выбора рамкой

     near_points(x_vrem,y_vrem,4);


     if (Point1.x = -1) and
        (Point1.y = -1) then
     begin
        Point1.x := x_vrem;
        Point1.y := y_vrem;

        WS.Canvas.Ellipse(round(x_vrem)-5,round(y_vrem)-5,
                          round(x_vrem)+5,round(y_vrem)+5);
        exit;
     end
     else
     begin
        if (orto_graph) then
        begin
           if abs(x_vrem-Point1.x) < abs(y_vrem-Point1.y) then
               x_vrem := Point1.x
           else
               y_vrem := Point1.y;
        end;

        //WS.Canvas.Ellipse(round(x_vrem)-5,round(y_vrem)-5,
        //                  round(x_vrem)+5,round(y_vrem)+5);

        save_prev();

        //Надо ли удалять объекты при зеркальном отражении
        case Application.MessageBox('Удалять исходные объекты?','',MB_YESNO) of
          ID_YES :
          begin
            //Зеркало с удалением исходных объектов
            MoveMirror(Point1.x, Point1.y, x_vrem, y_vrem);
          end;
          ID_NO :
          begin
            //Зеркало без удаления исходных объектов
            CopyMirror(Point1.x, Point1.y, x_vrem, y_vrem);
          end;
        end;

        Reset_mode;
        Clear;
        exit;
     end;
  end;

  //Указание точки для перетаскивая размера
  If (Selected<>10000) and
     (select_type = dim) then
     begin
         near_points(x_vrem,y_vrem,4);

         movedPoint := 0;

         if (x_vrem = DimAr[selected].x1) and
            (y_vrem = DimAr[selected].y1) then
            movedPoint := 1;
         if (x_vrem = DimAr[selected].x2) and
            (y_vrem = DimAr[selected].y2) then
            movedPoint :=2;
         if (x_vrem = DimAr[selected].x3) and
            (y_vrem = DimAr[selected].y3) then
            movedPoint := 3;
         if (x_vrem = DimAr[selected].x4) and
            (y_vrem = DimAr[selected].y4) then
            movedPoint := 4;
     end;

  //Отменить операцию//////////////////////////////////////////////////////
   if button = mbRight then
   begin
      BreakOperation;
      exit;
   end;

   //Добавление размера
   If (drawDimensionMode) then
   begin
       near_points(x_vrem,y_vrem,4);
       AddDimension(x_vrem, y_vrem);
       exit;
   end;

   //Поворот вокруг выбраной точки//////////////////////////////////////////
   if (RotMode) then
   begin
      FrameSelect_mode := false;
      //RotMode := false;
      near_points(x_vrem,y_vrem,4);
      Rotate(x_vrem,y_vrem);
      Reset_mode();
      exit;
   end;

   //Вписаный многоугольник//////////////////////////////////////////////////
   If (Draw_MultiAngleMode) then
   begin
       near_points(x_vrem,y_vrem,4);
       InMultAngle(x_vrem,y_vrem);
   end;

   //Описаный многоугольник///////////////////////////////////////////////////
   If (Draw_MultiAngleOutMode) then
   begin
       near_points(x_vrem,y_vrem,4);
       OutMultAngle(x_vrem,y_vrem);
   end;

   //Выбор рамкой//////////////////////////////////////////////////////////////
   if (FrameSelect_mode) then
   begin
     if (point1.X <> -1) and
        (point1.Y <> -1) then
         begin
             if Shift = [ssLeft,ssCtrl] then
                begin
                     SelectByFrame(point1.X,point1.Y,x_vrem,y_vrem, 0); //Исключить
                     exit;
                end
             else
             if Shift = [ssLeft,ssShift] then
                begin
                     SelectByFrame(point1.X,point1.Y,x_vrem,y_vrem, 2); //Добавить
                     exit;
                end
             else
                begin
                     setLength(multy_selected_line,0);
                     setLength(multy_selected_circle,0);
                     setLength(multy_selected_arcs,0);
                     setLength(multy_selected_point,0);
                     setLength(multy_selected_text,0);
                     setLength(multy_selected_arrow,0);
                     setLength(multy_selected_dim,0);

                     SelectByFrame(point1.X,point1.Y,x_vrem,y_vrem, 1); //Выбрать
                end;
         end
     else
         begin
             point1.X := x_vrem;
             point1.Y := y_vrem;
             exit;
         end;
   end;

   //Окружность по 3 точкам////////////////////////////////////////////////////
   If (draw_circle3points_mode) then
      begin
           save_prev();

           near_points(x_vrem,y_vrem,4);

           if (stad_cir3 = 0)  then
           begin
              point1.X := x_vrem;   //Ввод первой ординаты
              point1.Y := y_vrem;
              Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую точку';
              stad_cir3 := 1;
              exit;
           end;
           if (stad_cir3 = 1)  then
           begin
              point2.X := x_vrem;   //Ввод первой ординаты
              point2.Y := y_vrem;
              Form1.StatusBar1.Panels.Items[0].Text:='Укажи третью точку';
              stad_cir3 := 2;
              exit;
           end;

           point3.X := x_vrem;    //Ввод третьей точки и отрисовка
           point3.Y := y_vrem;

           Draw_circle_3_point(Point1, Point2, Point3);
           stad_cir3 := 0;
           point1.X := -1; point1.Y := -1;
           point2.X := -1; point2.Y := -1;
           point3.X := -1; point3.Y := -1;
           Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
      end;

   //Перемещение объекта//////////////////////////////////////////////////////////
   If (drag_point_mode) and
      not (Par_shift_mode) and
      not (Two_point_napr_mode) and
      not (cut_mode) and
      not (copy_mode) and
      not (get_centr_mass_mode)
      then //Если включен режим перетаскивания
   begin                     //то установить новые координаты объекта
      near_points(x_vrem,y_vrem,10);
      drag_point_mode:=false;
      Drag_selected:=-1;
      Selected := 10000;
      clear;
   end;

   if (selected<>10000) and
      not (Par_shift_mode) and
      not (Two_point_napr_mode) and
      not (cut_mode) and
      not (copy_mode)
      then  //Включить захват точки для перетаскивания
   begin
      save_prev();
      near_points(x_vrem,y_vrem,10);
      //Для линии и окружности
      If (select_type = line) or
         (select_type = Circle) then
         begin
            Drag_by_point(x_vrem,y_vrem);
            //exit;
         end;
      If (select_type = dim)  then //для размера
         begin
            Drag_by_point(x_vrem,y_vrem);
            //exit;
         end;
   end;

   //Рисование окружности по 2 ординатам/////////////////////////////////
   if (draw_circle2point_mode) then
   begin
       save_prev();

       near_points(x_vrem,y_vrem,4);
       if (point1.X = -1) and
          (point1.Y = -1) then
       begin
          point1.X := x_vrem;   //Ввод первой ординаты
          point1.Y := y_vrem;
          Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую ординату';
          stad_cir := true;
          exit;
       end;

       point2.X := x_vrem;    //Ввод второй ординаты и отрисовка
       point2.Y := y_vrem;

       Draw_circle_2_point(Point1, Point2);
       stad_cir := false;
       point1.X := -1; point1.Y := -1;
       Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую ординату';
   end;

   //Рисование дуги//////////////////////////////////////////////////////
   if (draw_arc_mode) then
   begin
       save_prev();

       near_points(x_vrem,y_vrem,4);
       if (point1.X = -1) and
          (point1.Y = -1) then
       begin
          point1.X := x_vrem;   //Ввод первой точки дуги
          point1.Y := y_vrem;
          Form1.WS.Canvas.Ellipse(round(x_vrem + Screen_x-5), round(y_vrem + Screen_y-5),
                                  round(x_vrem + Screen_x+5), round(y_vrem + Screen_y+5));
          Form1.StatusBar1.Panels.Items[0].Text:='Укажи вторую точку';
          exit;
       end;

       point2.X := x_vrem;    //Ввод второй точки и рисование дуги
       point2.Y := y_vrem;

       Form1.WS.Canvas.Ellipse(round(x_vrem + Screen_x-5), round(y_vrem + Screen_y-5),
                                  round(x_vrem + Screen_x+5), round(y_vrem + Screen_y+5));

       Draw_arc(Point1, Point2, -1);
       point1.X := -1; point1.Y := -1;
   end;

   ////Подсчет периметра/////////////////////////////////////////////////////
   if (get_perimetr_mode) then
   begin
      showmessage('Длина периметра равна ' + L_contur(x_vrem, y_vrem).toString);
      clear;
   end;
   /////////////////////////////////////////////////////////////////////////

   ////Подсчет центра тяжести///////////////////////////////////////////////
   if (get_centr_mass_mode) then //Нахождение центра тяжести
   begin
         Coord_CentrT(x_vrem,y_vrem);

         Reset_mode;
         Clear;
   end;

   //Измерение угла/////////////////////////////////////////////////////////
   if (get_angle_mode) then
   begin
      GetAngle(x_vrem,y_vrem);
   end;

   // Параллельная прямая///////////////////////////////////////////////////
   If (Par_shift_mode) then
   begin
       save_prev();

       //Старая формула
       //if (lines[selected].x1<>lines[selected].x2) then
       //   angle_line :=  ArcTan((lines[selected].y1-lines[selected].y2)/(lines[selected].x1-lines[selected].x2))
       //else angle_line:=DegToRad(-90);
       //angle_line := angle_line+DegToRad(90);

       //Процедура из модуля Calc
       with (lines[selected]) do
       angle_line := CalcAngle(x1,y1,x2,y2);
       angle_line := DegToRad(90)- angle_line;

       while (angle_line>DegToRad(360)) do
             angle_line -= DegToRad(360);
       while (angle_line<0) do
             angle_line += DegToRad(360);


       //Определение направления смещения////////////////////////////////////
       vremD := (x_vrem - lines[selected].x1)*
            (lines[selected].y2 - lines[selected].y1)-
            (y_vrem - lines[selected].y1)*
            (lines[selected].x2 - lines[selected].x1);

       If (vremD=0) then
       begin
          Reset_mode;
          exit;
       end;

       if (vremD<0) then
       begin
           if (angle_line>DegToRad(180)) then angle_line -= DegToRad(180);
       end;

       if (vremD>0) then
       begin
           if (angle_line<DegToRad(180)) then angle_line += DegToRad(180);
       end;
       //////////////////////////////////////////////////////////////////////


       shift_vrem := InputBox('Размер сдвига','Укажи размер сдвига','');
       if shift_vrem<>'' then
       begin
           shift_size := StrToFloat(shift_vrem);
       end;

       Lines[k].x1 := Lines[Selected].x1+shift_size*cos(angle_line);
       Lines[k].y1 := Lines[Selected].y1+shift_size*sin(angle_line);
       Lines[k].x2 := Lines[Selected].x2+shift_size*cos(angle_line);
       Lines[k].y2 := Lines[Selected].y2+shift_size*sin(angle_line);
       Lines[k].col := Lines[Selected].Col;
       Lines[k].style := Lines[Selected].style;
       Lines[k].Width := Lines[Selected].Width;
       Lines[k].id := id;
       id += 1;

       k+=1;

       clear;
       reset_mode;
       exit;
   end;

   //Направляющая через 2 точки////////////////////////////////////////////////
   If (Two_point_napr_mode) then
   begin
      save_prev();

      near_points(x_vrem,y_vrem,4);

      Ray2Point(x_vrem, y_vrem);

   end;

   //Горизонтальная направляющая///////////////////////////////////////////////
   If (Hor_napr_mode) then
   begin
      save_prev();

      near_points(x_vrem,y_vrem,4);

      lines[k].x1:=0;
      lines[k].y1:=y_vrem;
      lines[k].x2:=World_size_h;
      lines[k].y2:=y_vrem;
      lines[k].col:=clPurple;

       If Need_intersect_point.Checked then
       begin
          //проверка пересечения линий
          prov_intersect();
          //проверка пересечения с окружностью
          intersection_line_circ(k);
       end;

      Lines[k].id := id;
      id += 1;

      k+=1;

      clear;
   end;

   //Вертикальная направляющая////////////////////////////////////////////////
   If (Vert_napr_mode) then
   begin
      save_prev();

      near_points(x_vrem,y_vrem,4);

      lines[k].x1:=x_vrem;
      lines[k].y1:=0;
      lines[k].x2:=x_vrem;
      lines[k].y2:=World_size_v;
      lines[k].col:=clPurple;

       If Need_intersect_point.Checked then
       begin
          //проверка пересечения линий
          prov_intersect();
          //проверка пересечения с окружностью
          intersection_line_circ(k);
       end;

      Lines[k].id := id;
      id += 1;


      k+=1;

      clear;
   end;

   //Направляющая под углом///////////////////////////////////////////////////
   If (Angle_napr_mode) then
   begin
        save_prev();

        while (vrem='') do
        begin
          vrem := InputBox('Угол наклона прямой','Введи угол (против часовой стрелки)','');
          if (vrem = '') then
          begin
               ShowMessage('Некорректный угол');
               exit;
          end;

          if (StrToFloat(vrem)<-360) or
             (StrToFloat(vrem)>360) then ShowMessage('Некорректный угол');
        end;

      vrem_angle:=-StrToFloat(vrem);

      near_points(x_vrem,y_vrem,4);

      AngleRay(x_vrem,y_vrem, vrem_angle);
   end;

   //Вычисление площади, периметра и дистанции
   If (get_area_mode) then
   begin
      near_points(x_vrem,y_vrem,4);

      SetLength(point_list,Length(Point_List)+1);
      point_list[High(point_list)].X:=x_vrem+screen_x;
      point_list[High(point_list)].y:=y_vrem+screen_y;

      If (Length(point_list) > 2) then
      begin

      end;

      S_area := Calc3Par.S;
      Lper :=  Calc3Par.L1;
      Lway :=  Calc3Par.L2;

      StatusBar1.Panels.Items[3].Text:='Площ.='+FloatToStr(S_area)+
                                       '  /  Перим.='+FloatToStr(SimpleRoundTo(Lper,-3))+
                                       '  /  Изм.длина='+FloatToStr(SimpleRoundTo(Lway,-3));
   end;

   //Рисовать прямоугольник////////////////////////////////////////////////////
   If (draw_rectangle_mode = true) and not (Select_mode) then
       DrawRect(x_vrem, y_vrem);

   //Рисовать линию////////////////////////////////////////////////////////////
   If (Draw_line_mode = true) and not (Select_mode) then
       DrawLine(x_vrem, y_vrem);

  //Рисовать круг/////////////////////////////////////////////////////////////
  if (Draw_Circle_mode = true) and not (Select_mode)  then
      DrawCirc(x_vrem, y_vrem);

  //Добавить текст////////////////////////////////////////////////////////////
  If (Text_input_mode = true) and not (Select_mode) then
   begin
        save_prev(); //Сохранить предыдущее состояние

        Unit4.x_get:=x_vrem;
        Unit4.y_get:=y_vrem;
        Form4.Text_source.Text:='';
        Form4.Text_Size.ItemIndex:=0;
        Form4.ShowModal;

        Clear();
        Text_input_mode := false;
   end;

  //Выделить//////////////////////////////////////////////////////////////////
  if (Select_mode=true) then
   begin
        setLength(multy_selected_line,0);
        setLength(multy_selected_circle,0);
        setLength(multy_selected_arcs,0);
        setLength(multy_selected_point,0);
        setLength(multy_selected_text,0);
        setLength(multy_selected_arrow,0);
        setLength(multy_selected_dim,0);
        Clear();
        selected:=Select(x_vrem,y_vrem);
        exit;
   end;

   //Выделить  несколько/////////////////////////////////////////////////////
   if (multy_select_mode) then
   begin
        //Clear();
        selected:=Select(x_vrem,y_vrem);

        //Если объект уже был выбран ранее, то ф-ция Select вернет 10000
        if selected <> 10000 then
        case select_type of
          line:   begin
                 setLength(multy_selected_line,Length(multy_selected_line)+1);
                 multy_selected_line[High(multy_selected_line)] := selected;
               end;
          circle:   begin
                 setLength(multy_selected_circle,Length(multy_selected_circle)+1);
                 multy_selected_circle[High(multy_selected_circle)] := selected;
               end;
          dot:   begin
                 setLength(multy_selected_point,Length(multy_selected_point)+1);
                 multy_selected_point[High(multy_selected_point)] := selected;
               end;
          txt:   begin
                 setLength(multy_selected_text,Length(multy_selected_text)+1);
                 multy_selected_text[High(multy_selected_text)] := selected;
               end;
          arr:   begin
                 setLength(multy_selected_arrow,Length(multy_selected_arrow)+1);
                 multy_selected_arrow[High(multy_selected_arrow)] := selected;
               end;
          arc:   begin
                 setLength(multy_selected_arcs,Length(multy_selected_arcs)+1);
                 multy_selected_arcs[High(multy_selected_arcs)] := selected;
               end;
          dim:   begin
                 setLength(multy_selected_dim,Length(multy_selected_dim)+1);
                 multy_selected_dim[High(multy_selected_dim)] := selected;
               end;
        end;

        selected := 10000;

        exit;
   end;

   //Переместить///////////////////////////////////////////////////////////////
   if (cut_mode = true) then
       MoveObj(x_vrem, y_vrem);

  //Копировать///////////////////////////////////////////////////////////////
  if (copy_mode = true) then
        CopyObj(x_vrem, y_vrem);

  //Добавить стрелку//////////////////////////////////////////////////////////
  if (draw_arrow_mode = true) and not (Select_mode) then
     DrawArrow(x_vrem, y_vrem);

  //Измерить//////////////////////////////////////////////////////////////////
  If (Get_dim_mode = true) and not (Select_mode) then
       GetLength(x_vrem,y_vrem);
end;


procedure TForm1.WSMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer
  );

var
  delta_x, delta_y : double;
  x_vrem, y_vrem : double;

begin
  x_vrem := double(x);
  y_vrem := double(y);

  x_vrem := x_vrem-Screen_x;
  y_vrem := y_vrem-Screen_y;

  x_glob:=x_vrem; y_glob:=y_vrem;

  StatusBar1.Panels.Items[1].Text:='X='+FloatToStr(x_vrem);
  StatusBar1.Panels.Items[2].Text:='Y='+FloatToStr(y_vrem);

  near_points(x_vrem,y_vrem,4);

  //Установка курсора мыши
  SetMouseCursor(x_vrem,y_vrem);

  //Отрисовка линии симметрии для зеркала
  If (MirMode) and
     (Point1.x <> -1) and
     (Point1.y <> -1) then
     DrawMirLine(x_vrem,y_vrem);

  //Отрисовка нового положения объекта во время копирования или переноса
  If (((cut_mode) or (copy_mode)) and
     (stad_copy) and
     (MultiSelect))
     or
     (((selected<>10000) and ((cut_mode) or (copy_mode))) and (stad_copy))
     then
     begin
        WS.Canvas.Draw(0,0,imgTemp);

        delta_x:=X_vrem-x_copy;
        delta_y:=Y_vrem-y_copy;

        If (MultiSelect) then
           Selected := 10000;

        DrawMoved(delta_x,delta_y);  //Отображение объектов при перетаскивании
     end;
  ///////////////////////////////////////////////////////////////////////////

  //Отрисовка рамки при выборе рамкой
  if (FrameSelect_mode) then
   begin
     if (point1.X <> -1) and
        (point1.Y <> -1) then
         begin
            DrawFrame(x,y);
            exit;
         end;
   end;

  //Отрисовка окружности при построении по 2 ординатам
  If (draw_circle2point_mode) and
     (stad_cir) then
  begin
     PrepareDrawCirc2Ord(x_vrem, y_vrem, x, y);
     Exit;
  end;

  //Отрисовка прямоугольника при указании размера мышью
  If (draw_rectangle_mode) and
     (stad) then
     begin
        PrepareDrawRectangle(x_rect,y_rect,x_vrem,y_vrem, x, y);
        exit;
     end;

  //Отрисовка окружности при указании радиуса мышью
  If (draw_circle_mode) and
     (stad_cir) then
     begin
        PrepareDrawCircCentrRad(x_vrem, y_vrem, x, y);
        exit;
     end;

  //Отрисовка шаблона линии на экране
  If (draw_line_mode) and  //Рисование линии
     (stad) then
     begin
        PrepareDrawLine(x_vrem, y_vrem, x, y);
        exit;
     end;

  //Отрисовка шаблона линии на экране
  If (draw_line_mode) and //Рисование следующей точки линии
     ((last_point.x<>-1) and
     (last_point.y<>-1))
     then
  begin
    PrepareDrawNextLine(x_vrem, y_vrem, x, y);
    exit;
  end;

  //Отрисовка шаблона объектов при перетаскивании за точку
  If (drag_point_mode) and
     (Drag_selected<>-1) and
     (select_type <> dim)
     then
  begin
     PrepareDrawDotMoved(x_vrem, y_vrem, x, y);
     exit;
  end;

  //Отрисовка шаблона размера при перетаскивании за точку
  If (drag_point_mode) and
     (Drag_selected<>-1) and
     (select_type = dim) //and
     //(Drag_selected = selected)
     then
  begin
     PrepareDrawDotMoved(x_vrem, y_vrem, movedPoint);
     exit;
  end;
end;

procedure TForm1.WSPaint(Sender: TObject);
begin
  if start_prog = true then
   begin
      WS.Canvas.Brush.Color:=clWhite;
      WS.Canvas.FillRect(WS.Canvas.ClipRect);
      start_prog:=false;
   end;
end;

procedure TForm1.Delete_ObjClick(Sender: TObject); //Меню-удалить
begin
   Delete_Ob();
end;

procedure TForm1.DimensionClick(Sender: TObject); //Измерить
begin
    selected := 10000;

    clear();

    Reset_mode;
    get_dim_mode := true;

    Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
    If (NeedHelp) then
    ShowMessage('Укажи последовательно две точки');
end;

procedure TForm1.DrawBevelClick(Sender : TObject);
begin
  if length(multy_selected_line)>1 then
     AddBevel()
  else
     ShowMessage('Сначала необходимо выбрать отрезки');
end;

//Сборка блока
procedure TForm1.Draw_blockClick(Sender : TObject);
begin
   if (MultiSelect) then
      MakeBlock()
   else
   ShowMessage('Необходимо сначала выбрать объекты, из которых будет составлен блок');
end;


procedure BackStep;//Отмена последнего действия
begin
   lines:=copy(lines_vrem);
   circles:=copy(circles_vrem);
   arcs:=copy(arcs_vrem);
   points:=copy(points_vrem);
   nadp:=copy(nadp_vrem);
   arrow:=copy(arrow_vrem);
   DimAr := copy(DimAr_vrem);

   k:=k_vrem;
   k_cir:=k_cir_vrem;
   k_arc:=k_arc_vrem;
   k_points:=k_points_vrem;
   k_nadp:=k_nadp_vrem;
   k_arrow:=k_arrow_vrem;

   clear();
end;

procedure TForm1.backClick(Sender: TObject); //Отменить действие
begin
    BackStep();
end;

//Редактировать длину отрезка
procedure TForm1.ChangeLengthClick(Sender : TObject);
begin
  if (length(multy_selected_line) > 0) and
     (selected = 10000) then
     begin
         selected := multy_selected_line[0];
         select_type := line
     end;

  If ((Selected = 10000) or
     (select_type <> line))
     then
      begin
        Showmessage('Не выбран отрезок');
        exit;
      end;
  LetChangeLength;
end;

procedure TForm1.Change_line_styleClick(Sender : TObject);
begin
   Line_prop.ShowModal;

   Line_prop.ComboBox1.Text:=LineWeight.ToString;

   if LineStyle = psSolid then Line_prop.ComboBox2.ItemIndex:=0;
   if LineStyle = psDash then Line_prop.ComboBox2.ItemIndex:=1;
   if LineStyle = psDot then Line_prop.ComboBox2.ItemIndex:=2;
   if LineStyle = psDashDot then Line_prop.ComboBox2.ItemIndex:=3;
   if LineStyle = psDashDotDot then Line_prop.ComboBox2.ItemIndex:=4;
end;

procedure TForm1.Circle2PointClick(Sender : TObject);
begin
    Clear;

    Reset_mode;
    draw_circle2point_mode := true;

    Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';

    If (NeedHelp) then
    Showmessage('Необходимо последовательно указать две точки, являющиеся '+
                                               'ординатами окружности');
end;

procedure TForm1.Circle_3PointsClick(Sender : TObject);
begin
    Clear;

    Reset_mode;
    draw_circle3points_mode := true;

    Form1.StatusBar1.Panels.Items[0].Text:='Выбери первую точку';

    Showmessage('Необходимо последовательно указать три концевые точки отрезков, '+
                'между которых будет построена окружность');
end;

procedure TForm1.CircPanelClick(Sender : TObject);
begin

end;



procedure TForm1.Clear_podlClick(Sender: TObject); //Удалить подложку
begin
  loc:='';
  podl:=false;
  back_png.Free;
  clear();
  Clear_podl.Enabled:=false;
end;


procedure TForm1.add_backClick(Sender: TObject); //Добавить подложку
begin
     OpenDialog1.Filter:='Растровое изображение | *.bmp; *.png';
     OpenDialog1.FileName:='';

     If OpenDialog1.Execute then
     begin
          If OpenDialog1.FileName<>'' then
          begin
              loc:=OpenDialog1.FileName;
              Back_png:=TPortableNetworkGraphic.Create;

              if ExtractFileExt(loc)='.bmp' then
              begin
                   pic:=TBitmap.Create;
                   pic.LoadFromFile(loc);

                   back_png.Assign(pic);
                   pic.Free;
              end;

              if ExtractFileExt(loc)='.png' then
              begin
                   Back_png.LoadFromFile(loc);
              end;

              Form1.WS.Canvas.draw(0,0,Back_png);

              Back_png.SaveToFile(ExtractFilePath(F_name)+
                                        ExtractFileName(F_name)+'.png');

              podl:=true;
          end;
    if podl=true then Clear_podl.Enabled:=true;
    clear();
    end;
end;


procedure TForm1.Arc_buttonClick(Sender : TObject);
begin
  StatusBar1.Panels.Items[0].Text:='Укажи первую точку дуги';
  If NeedHelp then
     ShowMessage('Укажи конечные точки дуги');

  Reset_mode;
  Draw_arc_mode := true;
end;

procedure TForm1.AreaClick(Sender : TObject);  //Рассчитать площадь
begin
  Reset_mode;

  If (NeedHelp) then
  ShowMessage('Необходимо последовательно указать точки контура, площадь '+
              'которого надо измерить. Площадь и периметр будут указаны '+
              'в нижней части окна. Измеренное расстояние - суммарное '+
              'расстояние между всеми указанными точками');

  StatusBar1.Panels.Items[0].Text:='Укажи точку контура в порядке обхода';

  get_area_mode := true;

  SetLength(point_list,0);
end;

procedure TForm1.Arr_rightClick(Sender: TObject); //Стрелка вправо
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки стрелки';

  If (NeedHelp) then
   ShowMessage('Укажи точку вставки стрелки (точка острого окончания)');

  Reset_mode;
  draw_arrow_mode := true;

  arrow_kind:='right';//вправо
end;

procedure TForm1.Ar_downClick(Sender: TObject); //стрелка вниз
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки стрелки';

  If (NeedHelp) then
     ShowMessage('Укажи точку вставки стрелки (точка острого окончания)');

  Reset_mode;
  draw_arrow_mode := true;

  arrow_kind:='down';//вниз
end;

procedure TForm1.Ar_upClick(Sender: TObject); //Стрелка вверх
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки стрелки';

  If (NeedHelp) then
     ShowMessage('Укажи точку вставки стрелки (точка острого окончания)');

  Reset_mode;
  draw_arrow_mode := true;

  arrow_kind:='up';//вправо
end;

procedure TForm1.Copy_butClick(Sender: TObject);

var
 sel_vrem : integer;
 multy_selected_line_vrem,
 multy_selected_circle_vrem,
 multy_selected_arcs_vrem,
 multy_selected_point_vrem,
 multy_selected_text_vrem,
 multy_selected_arrow_vrem,
 multy_selected_dim_vrem: array of integer;

begin
 if (SelAllMode) then
 begin
     ShowMessage('Для копирования выбор всех объектов не применим');
     clear;
     exit;
 end;

 If (selected<>10000) or
    (MultiSelect) then
 begin
     sel_vrem := Selected;
     multy_selected_line_vrem := copy(multy_selected_line);
     multy_selected_circle_vrem := copy(multy_selected_circle);
     multy_selected_arcs_vrem := copy(multy_selected_arcs);
     multy_selected_point_vrem := copy(multy_selected_point);
     multy_selected_text_vrem := copy(multy_selected_text);
     multy_selected_arrow_vrem := copy(multy_selected_arrow);
     multy_selected_dim_vrem := copy(multy_selected_dim);

     Reset_mode;
     copy_mode:=true;
     Selected := sel_vrem;

     multy_selected_line := copy(multy_selected_line_vrem);
     multy_selected_circle := copy(multy_selected_circle_vrem);
     multy_selected_arcs := copy(multy_selected_arcs_vrem);
     multy_selected_point := copy(multy_selected_point_vrem);
     multy_selected_text := copy(multy_selected_text_vrem);
     multy_selected_arrow := copy(multy_selected_arrow_vrem);
     multy_selected_dim := copy(multy_selected_dim_vrem);

     Form1.StatusBar1.Panels.Items[0].Text:='Укажи базовую точку';
 end
 else
     begin
         showmessage('Не выбран ни один объект');
         exit;
     end;
end;

procedure TForm1.Cross_PointClick(Sender : TObject);//Точка пересечения отрезков
                                                    //или дуги
var
  k_vrem:integer;

begin
     If selected=10000 then
     begin
       If (NeedHelp) then
       Showmessage('Сначала необходимо выбрать объект, который с чем-то пересекается');
       Exit;
     end;

     save_prev();

     if select_type = arc then //выбрана дуга
     begin
         circles[k_cir].x := (arcs[selected].l_x+arcs[selected].r_x) / 2;
         circles[k_cir].y := (arcs[selected].t_y+arcs[selected].b_y) / 2;
         circles[k_cir].r := abs((arcs[selected].l_x-arcs[selected].r_x) / 2);
         circles[k_cir].id := id;

         id += 1;
         k_cir+=1;

         intersection_circ_line(k_cir-1);
         ////
         intersect_2_cir(Circles[k_cir-1].x, Circles[k_cir-1].y,
         Circles[k_cir-1].r);

         Delete(circles,k_cir-1,1);
         SetLength(circles, arr_length);
         k_cir-=1;

         clear;
         exit;
     end;

     If select_type = circle then //выбрана окружность
     begin
         intersection_circ_line(selected);
         intersect_2_cir(Circles[selected].x, Circles[selected].y,
         Circles[selected].r);

         clear;
         exit;
     end;

     If select_type = line then //выбрана линия
     begin
          sel_2 := Selected;

          k_vrem:=k;
          k := sel_2;
          prov_intersect();
          intersection_line_circ(k);

          k:=k_vrem;
          clear;
     end;
end;

procedure TForm1.Cut_butClick(Sender: TObject);

var
  sel_vrem : integer;
  multy_selected_line_vrem,
  multy_selected_circle_vrem,
  multy_selected_arcs_vrem,
  multy_selected_point_vrem,
  multy_selected_text_vrem,
  multy_selected_arrow_vrem,
  multy_selected_dim_vrem: array of integer;

begin
  If (selected<>10000) or
     (MultiSelect) then
  begin
      sel_vrem := Selected;
      multy_selected_line_vrem := copy(multy_selected_line);
      multy_selected_circle_vrem := copy(multy_selected_circle);
      multy_selected_arcs_vrem := copy(multy_selected_arcs);
      multy_selected_point_vrem := copy(multy_selected_point);
      multy_selected_text_vrem := copy(multy_selected_text);
      multy_selected_arrow_vrem := copy(multy_selected_arrow);
      multy_selected_dim_vrem := copy(multy_selected_dim);

      Reset_mode;
      cut_mode:=true;
      Selected := sel_vrem;

      multy_selected_line := copy(multy_selected_line_vrem);
      multy_selected_circle := copy(multy_selected_circle_vrem);
      multy_selected_arcs := copy(multy_selected_arcs_vrem);
      multy_selected_point := copy(multy_selected_point_vrem);
      multy_selected_text := copy(multy_selected_text_vrem);
      multy_selected_arrow := copy(multy_selected_arrow_vrem);
      multy_selected_dim := copy(multy_selected_dim_vrem);

      Form1.StatusBar1.Panels.Items[0].Text:='Укажи базовую точку';
  end
  else
     begin
         showmessage('Не выбран ни один объект');
         exit;
     end;
end;

procedure TForm1.Dr_line_coordClick(Sender: TObject); //Постр.линию по коорд.
begin
  Form3.x1.Text:='';
  Form3.y1.Text:='';
  Form3.x2.Text:='';
  Form3.y2.Text:='';
  Form3.x2.Visible:=true;
  Form3.y2.Visible:=true;
  Form3.label3.Visible:=true;
  Form3.label4.Visible:=true;

  Form3.ShowModal;

  Clear();
end;

procedure TForm1.Dr_RectClick(Sender: TObject); //Меню построить прямоугольник
begin
  Clear();

  Reset_mode;
  draw_rectangle_mode := true;

  Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';

  If (NeedHelp) then
  ShowMessage('Необходимо последовательно указать две угловых точки прямоугольника');
end;

procedure TForm1.FormCloseQuery(Sender : TObject; var CanClose : Boolean);
begin
    If NeedSave then
    case Application.MessageBox('Чертеж изменен. Сохранить файл?','Сохранить',MB_YESNOCANCEL) of
    ID_YES :
    begin
      // сохранение файла и закрытие программы
      SaveVector;
    end;
    ID_NO :
    begin
      // закрытие программы без сохранения

       canclose := true;
    end;
    ID_CANCEL :
     begin
       // отмена закрытия программы
       canclose:=false;
     end;
     end;
 end;


procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );

var
   d:integer = 1;
   vremAngle : double;
   XVrem, YVrem : double;

begin
  if sender = SelectChoiceMenu then exit;

  //Помощь
  If (Key = VK_F1) then Help_butClick(Sender as TObject);

  //Обновить рабочую область
  if (key = VK_F5) then Re_paintClick(Sender as TObject);

  if (MultiSelect)
    and
    (Key = VK_S)
    then SaveToBuf();

 If (Key = VK_DELETE) then
 begin
    key := 0;
    Delete_Ob;//удалить
    exit;
 end;

 If (Key = VK_ESCAPE) then //Отменить операцию
 begin
    BreakOperation;
    exit;
 end;

  If (Key = VK_Z) and  //Отмена последней операции
     (Shift = [ssCtrl]) then  BackStep();

  if ssShift in Shift then d:=10 else d:=1;

  If (Key = VK_RIGHT) then Move_vect(d,0);//вправо
  If (Key = VK_LEFT) then Move_vect(-d,0);//влево
  If (Key = vk_up) then Move_vect(0,-d);//вверх
  If (Key = VK_DOWN) then Move_vect(0,d);//вниз

  If ((Key=Ord('v')) or (Key=Ord('V'))) and //Загрузка подложки из буфера
     (ssCtrl in Shift) then
     begin
          if (f_name='')then
             begin
                showmessage('Чертеж не сохранен');
                exit;
             end;

          if Clipboard.HasFormat(CF_BITMAP) then
          begin
              pic:=TBitmap.Create;
              pic.LoadFromClipboardFormat(CF_BITMAP);

              pic.Canvas.StretchDraw(Rect(0,0,1200,900),pic);
              pic.Width:=1200;
              pic.Height:=900;


              back_png:=TPortableNetworkGraphic.Create;
              back_png.Assign(pic);

              back_png.SaveToFile(ExtractFilePath(F_name)+
                                            ExtractFileName(F_name)+'.png');
              loc:=ExtractFilePath(F_name)+ExtractFileName(F_name)+'.png';

              podl:=true;
              Clear_podl.Enabled:=true;

              Form1.WS.Canvas.draw(0,0,back_png);
           end;
          clear;
     end;
  If (((Key >= VK_0) and (Key<=VK_9)) or //Линия по углу и длине
  ((Key >= VK_NUMPAD0) and (Key <= VK_NUMPAD9))) and
  ((stad=true) or (contin_line) and (last_point.X<>-1) and (last_point.Y<>-1))
  then
  begin
      If ((Key >= VK_0) and (Key<=VK_9)) then d_length:=(StrToInt(chr(Key)));
      If (Key >= VK_NUMPAD0) then d_length:=0;
      If (Key >= VK_NUMPAD1) then d_length:=1;
      If (Key >= VK_NUMPAD2) then d_length:=2;
      If (Key >= VK_NUMPAD3) then d_length:=3;
      If (Key >= VK_NUMPAD4) then d_length:=4;
      If (Key >= VK_NUMPAD5) then d_length:=5;
      If (Key >= VK_NUMPAD6) then d_length:=6;
      If (Key >= VK_NUMPAD7) then d_length:=7;
      If (Key >= VK_NUMPAD8) then d_length:=8;
      If (Key >= VK_NUMPAD9) then d_length:=9;

      Near_points(x_glob,y_glob,4);

      if (contin_line) and
      (last_point.X<>-1) and
      (last_point.Y<>-1) then
      begin
         vremAngle := 180+RadToDeg(CalcAngle(x_glob,y_glob,last_point.X,last_point.Y));
      end
      else
         vremAngle := 180+RadToDeg(CalcAngle(x_glob,y_glob,lines[k].x1,lines[k].y1));
      if vremAngle >= 360 then vremAngle -= 360;


      //Для автоматического определения угла при задании длины отрезка
      //при режиме ОРТО///////////////////////////////////////////////////////
      if (contin_line) and
      (last_point.X<>-1) and
      (last_point.Y<>-1) then
      begin
          xVrem := last_point.X;
          yVrem := last_point.Y;
      end
      else
      begin
          xVrem := Lines[k].x1;
          yVrem := Lines[k].y1;
      end;

     if (Orto_graph = true) then
     begin
       if abs(x_glob-xVrem)<abs(y_glob-yVrem)
         then
             if y_glob > yVrem then
                vremAngle := 270
             else
                vremAngle := 90;
        if abs(x_glob-xVrem)>abs(y_glob-yVrem)
         then
             if x_glob > xVrem then
                vremAngle := 0
             else
                vremAngle := 180;
     end;
     //////////////////////////////////////////////////////////////////////////

      if draw_line_mode then
      begin
          Form6.Dlina.Text:=FloatToStr(d_length);
          Form6.Ugol.Text := FloatToStr(vremAngle);
          Form6.Label1.Caption:='Угол пр. час.стр.';
          Form6.Label2.Caption:='Длина';
          Form6.ShowModal;
          Stad:=false; //вернуться к первой точке
          d_length:=0;
      end;
      if draw_rectangle_mode then
      begin
          //Form6.Dlina.Text:=IntToStr(d_length);
          Form6.Label1.Caption:='Высота';
          Form6.Label2.Caption:='Ширина';
          Form6.ShowModal;
          Stad:=false; //вернуться к первой точке
          d_length:=0;
      end;
      clear;
  end;

  If (((Key >= VK_0) and (Key<=VK_9)) or //Окружность по радиусу
  ((Key >= VK_NUMPAD0) and (Key <= VK_NUMPAD9))) and (stad_cir=true) then
  begin
      If ((Key >= VK_0) and (Key<=VK_9)) then d_length:=(StrToInt(chr(Key)));
      If (Key >= VK_NUMPAD0) then d_length:=0;
      If (Key >= VK_NUMPAD1) then d_length:=1;
      If (Key >= VK_NUMPAD2) then d_length:=2;
      If (Key >= VK_NUMPAD3) then d_length:=3;
      If (Key >= VK_NUMPAD4) then d_length:=4;
      If (Key >= VK_NUMPAD5) then d_length:=5;
      If (Key >= VK_NUMPAD6) then d_length:=6;
      If (Key >= VK_NUMPAD7) then d_length:=7;
      If (Key >= VK_NUMPAD8) then d_length:=8;
      If (Key >= VK_NUMPAD9) then d_length:=9;


      Circles[k_cir].r := StrToFloat(Inputbox('Рисование окружности',
                                     'Введи радиус',IntToStr(d_length*100)));
      if Circles[k_cir].r<>0 then
      begin
          Circles[k_cir].col:=Cvet;
          Circles[k_cir].id := id;
          id += 1;
          //Отрисовка ординат
          //1
          points[k_points].x:=Circles[k_cir].x;
          points[k_points].y:=Circles[k_cir].y-Circles[k_cir].r;
          points[k_points].id := id;
          id +=1;
          //2
          points[k_points+1].x:=Circles[k_cir].x;
          points[k_points+1].y:=Circles[k_cir].y+Circles[k_cir].r;
          points[k_points].id := id;
          id +=1;
          //3
          points[k_points+2].x:=Circles[k_cir].x-Circles[k_cir].r;
          points[k_points+2].y:=Circles[k_cir].y;
          points[k_points].id := id;
          id +=1;
          //4
          points[k_points+3].x:=Circles[k_cir].x+Circles[k_cir].r;
          points[k_points+3].y:=Circles[k_cir].y;
          points[k_points].id := id;
          id +=1;
          //Центр
          points[k_points+4].x:=Circles[k_cir].x;
          points[k_points+4].y:=Circles[k_cir].y;
          points[k_points].id := id;
          id +=1;

          k_points+=5;
          k_cir+=1;

          intersection_circ_line(k_cir-1);
      end

      else
      begin
          Delete(Circles,selected,1);
          SetLength(Circles,arr_length);
      end;
      Clear;
      stad_cir:=false;
  end;
 end;

procedure TForm1.FormResize(Sender : TObject);
begin
  imgTemp.Width := WS.Width;
  imgTemp.Height := WS.Height;
end;


procedure TForm1.FormWindowStateChange(Sender : TObject);
begin
  WS.Refresh;
  SelectChoiceMenu.Repaint;

  //Form1.Repaint;

  Start_timer_delay.Enabled:=true;
end;

procedure TForm1.Get_AngleClick(Sender : TObject);
begin
   selected := 10000;

   Clear;

   Reset_mode;

   get_angle_mode := true;
   Form1.StatusBar1.Panels.Items[0].Text:='Укажи послед. точки пересек. отрезков';

   If (NeedHelp) then
   ShowMessage('Укажи три точки (окончание первого отрезка, точка пересечения, '+
               'окончание второго отрезка');
end;

procedure TForm1.Get_Centr_MassClick(Sender : TObject);
begin
  selected := 10000;

  Clear;
  Reset_mode;
  get_centr_mass_mode := true;
  P_show := false;

  //Отключить отображение точек
  vremShowPset := Show_pset.Checked;
  P_show := false;
  clear;
  Show_pset.Checked := false;

  Form1.StatusBar1.Panels.Items[0].Text:='Укажи точку внутри замкнутого контура';

  If (NeedHelp) then
  ShowMessage('Укажи точку внутри замкнутого контура');
end;

procedure TForm1.Add_VectorClick(Sender: TObject);//Добавить вектор

var
  f_name:string = '';

begin
   save_prev(); //Сохранить предыдущее состояние

   OpenDialog1.Filter:='Файл Vector | *.vp';
   OpenDialog1.FileName:='';

   If OpenDialog1.Execute then
       f_name:=OpenDialog1.FileName;
   if f_name<>'' then  Add_vect(f_name);

   add_back.Enabled:=true;

   Clear();
end;

procedure TForm1.Div_2Click(Sender: TObject);//Точка середины отрезка
begin
  midle_point();
end;

procedure TForm1.Clear_allClick(Sender: TObject);//Кнопка удалить все
begin
   Clear_all_fig();
   Save_as_menu.Enabled:=false;

   NeedSave := false;
end;

procedure TForm1.KrugClick(Sender : TObject);
begin
   Clear;

   Reset_mode;
   draw_circle_mode := true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи центр окружности';

     If (NeedHelp) then
   Showmessage('Необходимо указать точку - центр окружности');
end;

procedure TForm1.LineDimClick(Sender : TObject);
begin
  Clear;
  Reset_mode;
  drawDimensionMode := true;//Режим добавления размера

  Form1.StatusBar1.Panels.Items[0].Text:='Выбери первую точку';

  If NeedHelp then
  Showmessage('Необходимо указать две точки, расстояние между которых необходимо измерить');
end;

procedure TForm1.Mirror_menuClick(Sender : TObject);
begin
  clear;
  //Reset_mode;
  MirMode := true;

  if (selected = 10000) and
        (Length(multy_selected_line) = 0) and
        (Length(multy_selected_circle) = 0) and
        (Length(multy_selected_arcs) = 0)  and
        (Length(multy_selected_point) = 0) and
        (Length(multy_selected_text) = 0) and
        (Length(multy_selected_arrow) = 0) then
     begin
        ShowMessage('Сначала нужно выбрать объекты для отражения');
        exit;
     end;

  Form1.StatusBar1.Panels.Items[0].Text:='Выбери первую точку линии симметрии';

  If NeedHelp then
  Showmessage('Необходимо указать две точки, определяющие линию, яляющуюся линией симметрии');


end;

procedure TForm1.OrtoDimSelectClick(Sender : TObject);
begin
  Clear;
  Reset_mode;

  drawDimensionMode := true;//Режим добавления размера
  OrtoDim := true;

  Form1.StatusBar1.Panels.Items[0].Text:='Выбери первую точку';

  If NeedHelp then
  Showmessage('Необходимо указать две точки, расстояние между которых необходимо измерить');
end;

//Построение точки на пересечении продолжения отрезка
procedure TForm1.PointCrossStretchedClick(Sender : TObject);
begin
  if (Length(multy_selected_line)<>2) then
  begin
      showmessage('Должны быть выбраны: 1 - линия, длина которой будет изменяться, '+
                  '2 - линия-ограничитель');
      exit;
  end;

  PointCross2Line(multy_selected_line[0],multy_selected_line[1], true);

  Clear;
end;

procedure TForm1.PsetClick(Sender : TObject);
begin
  save_prev(); //Сохранить предыдущее состояние

  Form3.x1.Text:='';
  Form3.y1.Text:='';
  Form3.x2.Text:='';
  Form3.y2.Text:='';
  Form3.x2.Visible:=false;
  Form3.y2.Visible:=false;
  Form3.label3.Visible:=false;
  Form3.label4.Visible:=false;

  Form3.ShowModal;

   if (k_points>0) then    back.Enabled:=true;

  Clear();
end;

procedure TForm1.RoundEdgeMenuClick(Sender : TObject);
begin
  if length(multy_selected_line)>1 then
     RoundEdge()
  else
     ShowMessage('Сначала необходимо выбрать отрезки');
end;

//Удлинить или обрезать отрезок
procedure TForm1.Stretch_trimClick(Sender : TObject);

var
  vremLanesArr : array [0..1] of integer;

begin
  if (Length(multy_selected_line)<>2) then
  begin
      showmessage('Должны быть выбраны: сначала линия, длина которой будет изменяться, '+
                  'Затем линия-ограничитель');
      exit;
  end;

  vremLanesArr[0] := multy_selected_line[0];
  vremLanesArr[1] := multy_selected_line[1];

  Reset_mode;

  SetLength(multy_selected_line,2);
  multy_selected_line[0] := vremLanesArr[0];
  multy_selected_line[1] := vremLanesArr[1];

  Trim();

  Clear;
end;

procedure TForm1.OutMultiAngleClick(Sender : TObject);
begin
    Reset_mode();
    Draw_MultiAngleOutMode := true;
    Form1.StatusBar1.Panels.Items[0].Text:='Укажи центр многоугольника';

    If (NeedHelp) then
    Showmessage('Необходимо указать точку - центр окружности, вокруг которой '+
                                                 'описан многоугольник');
end;

procedure TForm1.L_vectorClick(Sender: TObject); //Загрузить новый вектор

var
  f_name_op:string = '';

begin
   OpenDialog1.Filter:='Файл Vector | *.vp';
   OpenDialog1.FileName:='';

   If OpenDialog1.Execute then
       f_name_op:=OpenDialog1.FileName;
   if f_name_op<>'' then Load_vect(f_name_op);

   add_back.Enabled:=true;
   if podl=true then Clear_podl.Enabled:=true;

   Save_as_menu.Enabled:=true;
end;

procedure TForm1.Help_butClick(Sender: TObject);//Помощь
begin
   OpenDocument('help.pdf');
end;

procedure TForm1.Arr_leftClick(Sender: TObject);
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки стрелки';

  If (NeedHelp) then
     ShowMessage('Укажи точку вставки стрелки (точка острого окончания)');

  Reset_mode;
  draw_arrow_mode := true;

  arrow_kind:='left';//влево

end;

procedure TForm1.Draw_hor_naprClick(Sender : TObject);
begin
   Clear();

   Reset_mode;
   Hor_napr_mode := true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи точку';

   If (NeedHelp) then
   ShowMessage('Необходимо указать точку, через которую пройдет направляющая');
end;

procedure TForm1.Break_blockClick(Sender : TObject);
begin
   if (block_num = -1) then
   begin
      ShowMessage('Блок не выбран');
      exit;
   end;

   delete(blocks, block_num,1);
   ShowMessage('Блок разрушен');
   clear;
   //setlength(blocks,arr_length,1000);
   block_num := -1;
end;

procedure TForm1.FrameSelectClick(Sender : TObject);
begin
   Reset_mode;
   FrameSelect_mode := true;
   Selected := 10000;


   If FrameSelect_mode = true then
             Form1.StatusBar1.Panels.Items[0].Text:='Укажи угол рамки'
   Else Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
end;

procedure TForm1.CopyToRastrBufferClick(Sender : TObject);
begin
   if not MultiSelect then
       if (selected <> 10000) then
          TranslateSingleToMulti
       else
          begin
             ShowMessage('Не был выбран ни один объект');
             exit;
          end;

      SaveToBuf();
      If (NeedHelp) then
      ShowMessage('В буфере обмена находится растровое изображение выбранных элементов '+
      'для вставки в другие приложения');
end;

procedure TForm1.Multy_Select_butttonClick(Sender : TObject);
begin
  Clear;
  Reset_mode;

  Multy_select_mode := true;

  If Multy_select_mode = true then
         Form1.StatusBar1.Panels.Items[0].Text:='Выбери объекты'
end;

procedure TForm1.InMultiAngleClick(Sender : TObject);
begin
  Reset_mode();
  Draw_MultiAngleMode := true;
  Form1.StatusBar1.Panels.Items[0].Text:='Укажи центр многоугольника';

  If (NeedHelp) then
  Showmessage('Необходимо указать точку - центр окружности, в которую вписан '+
                                               'многоугольник');
end;


procedure TForm1.Paral_naprClick(Sender : TObject);

var
  sel_vrem : integer;

begin
   Clear();

  if (selected = 10000) and
     (length(multy_selected_line)>0)
     then
     begin
          selected := multy_selected_line[0];
          select_type := line;
     end;

   sel_vrem := Selected;
   Reset_mode;
   Selected := Sel_vrem;


   if (selected<>10000) and
      (select_type = 1) then      //Выбрана линия
   begin
     par_shift_mode:=true;
     Form1.StatusBar1.Panels.Items[0].Text:='Укажи направление смещения';
     if NeedHelp then ShowMessage('Укажи направление смещения');
   end
   else
     begin
         showmessage('Объект не выбран или не является отрезком');
         exit;
     end;
end;

procedure TForm1.PerimetrClick(Sender : TObject); //Измерить периметр контура
begin
  selected := 10000;

  Clear;
  Reset_mode;
  get_perimetr_mode := true;

  StatusBar1.Panels.Items[0].Text:='Укажи точку внутри контура';
end;

procedure TForm1.Save_as_menuClick(Sender : TObject);
begin
     SaveDialog1.Filter:='Векторное изображение | *.vp';
     SaveDialog1.FileName:='';

     If SaveDialog1.Execute then
          f_name:=SaveDialog1.FileName;
     if f_name<>'' then Save_vect(f_name);
end;

procedure TForm1.Scroll_hChange(Sender : TObject);
begin
  ///Start_timer_delay.Enabled:=true;
  Screen_x := -Scroll_h.Position;
  //WS.Left := -Scroll_h.Position;
  //Showmessage(WS.Left.ToString);
  clear;
end;

procedure TForm1.Scroll_vChange(Sender : TObject);
begin
  //Start_timer_delay.Enabled:=true;
  Screen_y := -Scroll_v.Position;
  //WS.Top := -Scroll_v.Position;
  //Showmessage(WS.Left.ToString);
  clear;
end;

procedure TForm1.ShHelpClick(Sender : TObject);
begin
  If (ShHelp.Checked) then NeedHelp := true
  else NeedHelp := false;
end;

procedure TForm1.Shift_XClick(Sender : TObject);

var
  Sdvig_txt: string;
  Sdvig : double;
  k_vrem : integer;
  count : integer;

begin
  If selected<>10000 then TranslateSingleToMulti();

  if (MultiSelect) then
  begin
     Sdvig_txt := InputBox('Смещение', 'Укажи смещение по X', '');
     if Sdvig_txt='' then exit;
     Sdvig := StrToFloat(Sdvig_txt);

     save_prev();

     for count:=0 to Length(multy_selected_line)-1 do
     begin
        Lines[multy_selected_line[count]].x1+=Sdvig;
        Lines[multy_selected_line[count]].x2+=Sdvig;

        k_vrem:=k;
        k := multy_selected_line[count];
        prov_intersect();
        intersection_line_circ(k);
        k:=k_vrem;
     end;
     for count:=0 to Length(multy_selected_circle)-1 do
     begin
        Circles[multy_selected_circle[count]].x+=Sdvig;

        k_vrem:=k_cir;
        k_cir := multy_selected_circle[count];
        intersection_circ_line(k_cir);
        k_cir:=k_vrem;
     end;
     for count:=0 to Length(multy_selected_arcs)-1 do
     begin
        Arcs[multy_selected_arcs[count]].x1+=Sdvig;
        Arcs[multy_selected_arcs[count]].x2+=Sdvig;
        Arcs[multy_selected_arcs[count]].l_x+=Sdvig;
        Arcs[multy_selected_arcs[count]].r_x+=Sdvig;

        //k_vrem:=k_arc;
        //k_arc := multy_selected_arc[count];
        //intersection_circ_line(k_cir);
        //k_cir:=k_vrem;
     end;
     for count:=0 to Length(multy_selected_point)-1 do
     begin
        points[multy_selected_point[count]].x+=Sdvig;
     end;
     for count:=0 to Length(multy_selected_text)-1 do
     begin
        nadp[multy_selected_text[count]].x+=Sdvig;
     end;
     for count:=0 to Length(multy_selected_arrow)-1 do
     begin
        nadp[multy_selected_arrow[count]].x+=Sdvig;
     end;
     for count:=0 to Length(multy_selected_dim)-1 do
     begin
        DimAr[multy_selected_dim[count]].x1+=Sdvig;
        DimAr[multy_selected_dim[count]].x2+=Sdvig;
        DimAr[multy_selected_dim[count]].x3+=Sdvig;
        DimAr[multy_selected_dim[count]].x4+=Sdvig;
        DimAr[multy_selected_dim[count]].nadpCX+=Sdvig;
     end;

     Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
     stad_copy:=false;
     select_type:=0;
     selected:=10000;
     cut_mode:=false;
     Clear();

     SetLength(multy_selected_line,0);
     SetLength(multy_selected_circle,0);
     SetLength(multy_selected_arcs,0);
     SetLength(multy_selected_point,0);
     SetLength(multy_selected_text,0);
     SetLength(multy_selected_arrow,0);
     SetLength(multy_selected_dim,0);

     exit;
  end;

  showmessage('Не выбран ни один объект');
  exit;

end;

procedure TForm1.Shift_YClick(Sender : TObject);

var
  Sdvig_txt: string;
  Sdvig : double;
  k_vrem : integer;
  count : integer;

begin
   If selected<>10000 then TranslateSingleToMulti();

   if (MultiSelect) then
   begin
      Sdvig_txt := InputBox('Смещение', 'Укажи смещение по Y', '');
      if Sdvig_txt='' then exit;
      Sdvig := StrToFloat(Sdvig_txt);

      save_prev();

      for count:=0 to Length(multy_selected_line)-1 do
      begin
         Lines[multy_selected_line[count]].y1+=Sdvig;
         Lines[multy_selected_line[count]].y2+=Sdvig;

         k_vrem:=k;
         k := multy_selected_line[count];
         prov_intersect();
         intersection_line_circ(k);
         k:=k_vrem;
      end;
      for count:=0 to Length(multy_selected_circle)-1 do
      begin
         Circles[multy_selected_circle[count]].y+=Sdvig;

         k_vrem:=k_cir;
         k_cir := multy_selected_circle[count];
         intersection_circ_line(k_cir);
         k_cir:=k_vrem;
      end;
      for count:=0 to Length(multy_selected_arcs)-1 do
      begin
         Arcs[multy_selected_arcs[count]].y1+=Sdvig;
         Arcs[multy_selected_arcs[count]].y2+=Sdvig;
         Arcs[multy_selected_arcs[count]].t_y+=Sdvig;
         Arcs[multy_selected_arcs[count]].b_y+=Sdvig;

         //k_vrem:=k_cir;
         //k_cir := multy_selected_circle[count];
         //intersection_circ_line(k_cir);
         //k_cir:=k_vrem;
      end;
      for count:=0 to Length(multy_selected_point)-1 do
      begin
         points[multy_selected_point[count]].y+=Sdvig;
      end;
      for count:=0 to Length(multy_selected_text)-1 do
      begin
         nadp[multy_selected_text[count]].y+=Sdvig;
      end;
      for count:=0 to Length(multy_selected_arrow)-1 do
      begin
         nadp[multy_selected_arrow[count]].y+=Sdvig;
      end;
      for count:=0 to Length(multy_selected_dim)-1 do
     begin
        DimAr[multy_selected_dim[count]].y1+=Sdvig;
        DimAr[multy_selected_dim[count]].y2+=Sdvig;
        DimAr[multy_selected_dim[count]].y3+=Sdvig;
        DimAr[multy_selected_dim[count]].y4+=Sdvig;
        DimAr[multy_selected_dim[count]].nadpCY+=Sdvig;
     end;

      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
      stad_copy:=false;
      select_type:=0;
      selected:=10000;
      cut_mode:=false;
      Clear();

      SetLength(multy_selected_line,0);
      SetLength(multy_selected_circle,0);
      SetLength(multy_selected_arcs,0);
      SetLength(multy_selected_point,0);
      SetLength(multy_selected_text,0);
      SetLength(multy_selected_arrow,0);
      SetLength(multy_selected_dim,0);

      exit;
   end;

   showmessage('Не выбран ни один объект');
   exit;
end;

procedure TForm1.Menu_AddTextClick(Sender: TObject); //Добавить текст
begin
  StatusBar1.Panels.Items[0].Text:='Укажи точку вставки текста';
  If (NeedHelp) then
     ShowMessage('Укажи точку вставки текста');
  Reset_mode;
  Text_input_mode:=true;
end;


procedure TForm1.Draw_lineClick(Sender: TObject); //Чертить линию
begin
   Clear();

   Reset_mode;
   draw_line_mode:=true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';

   If (NeedHelp) then
   ShowMessage('Необходимо последовательно указать 2 конечные точки отрезка');
end;

procedure TForm1.Draw_napr_2pointClick(Sender : TObject);
begin
   Clear();

   Reset_mode;
   Two_point_napr_mode := true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи точку';

   If (NeedHelp) then
   ShowMessage('Необходимо указать две точки, через которые пройдет направляющая');
end;

procedure TForm1.Draw_napr_angleClick(Sender : TObject);
begin
   Clear();

   Reset_mode;
   Angle_napr_mode := true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи точку';

   If (NeedHelp) then
   ShowMessage('Необходимо указать точку, через которую пройдет направляющая');
end;

procedure TForm1.Draw_vert_naprClick(Sender : TObject);
begin
   Clear();

   Reset_mode;
   Vert_napr_mode := true;

   Form1.StatusBar1.Panels.Items[0].Text:='Укажи точку';

   If (NeedHelp) then
   ShowMessage('Необходимо указать точку, через которую пройдет направляющая');
end;

procedure TForm1.ModifyClick(Sender: TObject);//Редактировать
begin
   save_prev(); //Сохранить предыдущее состояние

   If select_type = arc then exit; //Дугу нельзя изменить в этом меню

   if (Selected = 10000) then
     if (length(multy_selected_line) <>0) then
     begin
        Selected := multy_selected_line[0];
        select_type := line;
     end
     else if (length(multy_selected_circle) <> 0) then
     begin
        Selected := multy_selected_circle[0];
        select_type := circle;
     end
     else if (length(multy_selected_point) <> 0) then
     begin
        Selected := multy_selected_point[0];
        select_type := dot;
     end
     else if (length(multy_selected_text) <> 0) then
     begin
        selected := multy_selected_text[0];
        select_type := txt;
     end
     else if (length(multy_selected_arrow) <> 0) then
     begin
        Selected := multy_selected_arrow[0];
        select_type := arr;
     end;

   If (select_type <> dim) then
   If (selected<>10000) then Form2.ShowModal
   else
     begin
         showmessage('Не выбран объект');
         exit;
     end;

   Form1.StatusBar1.Panels.Items[0].Text:='Не выбран ни один объект';
   selected:=10000;
   Clear();
end;

procedure TForm1.One_to_TwoClick(Sender: TObject);//Разделить отрезок на 2 части

var
  x11,y11,x21,y21,
  x22,y22:double;
  col:Tcolor;
  vrem : integer;

begin
  If ((Selected<>10000) and (Select_type = line)) or
     (Length(multy_selected_line)=1)
     then
  begin
      save_prev(); //Сохранить предыдущее состояние

      if selected = 10000 then selected := multy_selected_line[0];

      //Если линия входила в блок
      vrem := Prov_Sel_Block(FindLineNumber(selected));
      if (vrem <> -1) then
         DeleteBlock(vrem);

      x11:=lines[selected].x1;
      x22:=lines[selected].x2;
      y11:=lines[selected].y1;
      y22:=lines[selected].y2;
      col:=lines[selected].col;

      x21:=min(x22,x11)+abs(x22-x11)/2;
      y21:=min(y22,y11)+abs(y22-y11)/2;

      Delete(lines,selected,1);
      SetLength(lines,arr_length);
      k-=1;

      Lines[k].x1:=x11; Lines[k].y1:=y11;
      Lines[k].x2:=x21; Lines[k].y2:=y21;
      Lines[k].col:=col;
      Lines[k].id := id;
      id += 1;
      k+=1;

      Lines[k].x1:=x21; Lines[k].y1:=y21;
      Lines[k].x2:=x22; Lines[k].y2:=y22;
      Lines[k].col:=col;
      Lines[k].id := id;
      id += 1;
      k+=1;

      Points[k_points].x:=x21; Points[k_points].y:=y21;
      Points[k_points].id := id;
      id += 1;
      k_points+=1;

      clear();
  end
  else
  begin
         showmessage('Не выбран единичный объект, либо объект не является отрезком');
         exit;
  end;
end;

procedure TForm1.ORTOClick(Sender: TObject); //Ортогональный режим
begin
    Orto_graph:= not Orto_graph;
end;


procedure TForm1.Rectangle_coordClick(Sender: TObject);//Прямоугольник по коорд.
begin
    save_prev(); //Сохранить предыдущее состояние

    Reset_mode;
    rect_mode:=true;

    Form3.x1.Text:='';
    Form3.y1.Text:='';
    Form3.x2.Text:='';
    Form3.y2.Text:='';
    Form3.x2.Visible:=true;
    Form3.y2.Visible:=true;
    Form3.label3.Visible:=true;
    Form3.label4.Visible:=true;

    Form3.ShowModal;

    Clear();

    rect_mode:=false;
end;

procedure TForm1.Re_paintClick(Sender: TObject); //Обновить изображение
begin
      Clear();
      Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
end;

procedure TForm1.Rot_selClick(Sender: TObject); //Поворот фигуры (линии)
begin
     if (Selected = 10000) and
     not (MultiSelect) then
     begin
         showmessage('Не выбран ни один объект');
         exit;
     end;

     ShowMessage('Укажи точку - центр поворота');
     Form1.StatusBar1.Panels.Items[0].Text:='Укажи центр поворота';
     RotMode := true;
     WS.Cursor := crDefault;
     //Rotate();
end;

procedure TForm1.Save_ScriptClick(Sender: TObject); //Сохранить скрипт VBS
begin
  SaveScript();
end;

procedure TForm1.Select_colorClick(Sender: TObject);//Выбор цвета
begin
   If ColorDialog1.Execute then Cvet := ColorDialog1.Color;
end;


procedure TForm1.Show_psetClick(Sender: TObject); //Меню - Показывать точки
begin
  P_show:=not P_show;
  Clear;
end;

procedure TForm1.Size_draftClick(Sender : TObject);

var
  vremStr : string = '';
  vrem_width, vrem_height : integer;

begin
  if not InputQuery('','Укажи ширину поля чертежа (если <= 0,'+
                #13 + 'то размер чертежа будет равен окна). '+
                #13 + 'Сейчас ширина равна ' + WS.Width.ToString,
                vremStr) then exit;
  vrem_width := vremStr.ToInteger();
  if not InputQuery('','Укажи высоту поля чертежа (если <= 0,'+
                #13 + 'то размер чертежа будет равен окна). '+
                #13 + 'Сейчас высота равна ' + WS.Height.ToString,
                vremStr) then exit;
   vrem_height := vremStr.ToInteger();

  //vrem_width := InputBox('Новый размер поля чертежа', 'Укажи ширину поля чертежа (если <=0,'+
  //                       #13 + 'то размер чертежа равен окна). '+
  //                       #13 + 'Сейчас ширина равна ' + WS.Width.ToString, WS.Width.ToString).ToInteger;
  //vrem_height := InputBox('Новый размер поля чертежа', 'Укажи высоту поля чертежа (если <=0,'+
  //                        #13 + 'то размер чертежа равен окна).'+
  //                        #13 + 'Сейчас высота равна ' + WS.Height.ToString, WS.Height.ToString).ToInteger;

  if (vrem_width <= 0) or
     (vrem_height <= 0) then
     begin
        WS.Width := Panel1.Width;
        WS.Height := Panel1.Height;
     end
  else
  begin
      WS.Width := vrem_width;
      WS.Height := vrem_height;
  end;

  Scroll_h.Position := 0;
  Scroll_v.Position := 0;

  if WS.Width-Panel1.Width > 0 then
     begin
          Scroll_h.Max := WS.Width-Panel1.Width;
          Scroll_h.Enabled := true;
     end
  else
    Scroll_h.Enabled:=false;
  if WS.Height-Panel1.Height > 0 then
     begin
          Scroll_v.Max := WS.Height-Panel1.Height;
          Scroll_v.Enabled := true;
     end
  else
    Scroll_v.Enabled := false;

  Start_timer_delay.Enabled:=true;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnActivate := Form1.OnWindowStateChange;

  my.DecimalSeparator := '.';

  imgTemp := TPortableNetworkGraphic.Create;
  imgTemp.Width := WS.Width;
  imgTemp.Height := WS.Height;

  SetLength(lines,arr_length);
  SetLength(Circles,arr_length);
  SetLength(arcs,arr_length);
  SetLength(points,arr_length);
  SetLength(nadp,arr_length);
  SetLength(arrow,arr_length);

  If ParamCount > 0 then
  //Showmessage(ParamStr(1));
  begin
      Load_vect(ParamStr(1));
      add_back.Enabled:=true;
      if podl=true then Clear_podl.Enabled:=true;
      Start_timer_delay.Enabled:=true;
  end;

  WS.Canvas.Brush.Style:=bsClear;

  WS.Width := World_size_h;
  WS.Height := World_size_v;

  Scroll_h.Max := abs(WS.Width - Panel1.Width);
  Scroll_v.Max := abs(WS.Height - Panel1.Height);


  last_point.X := -1;    //Точка для непрерывного ввода линии
  last_point.Y := -1;

  Point1.X := -1;        //Точка для рисования дуг
  Point1.Y := -1;

  save_prev();

  NeedSave := false;
end;

procedure TForm1.Sel_allClick(Sender: TObject); //Выбрать всё
begin
  Reset_mode;
  select_mode := true; //Режим выделения по умолчанию

  Select_type:=0;

  Form5.L_sel.Checked:=true; //Выбор всех линий
  Form5.c_sel.Checked:=true; //Выбор всех окружностей
  Form5.p_sel.Checked:=true;  //Выбор всех точек
  Form5.t_sel.Checked:=true;  //Выбор всех текстов
  Form5.arr_sel.Checked:=true;  //Выбор всех стрелок
  Form5.arc_sel.Checked:=true;  //Выбор всех дуг
  Form5.DimSel.Checked:=true;  //Выбор всех размеров

  Form5.ShowModal;
  Form1.StatusBar1.Panels.Items[0].Text:=
                          'Выбрано мн. элементов';
end;

procedure TForm1.Show_back_butClick(Sender: TObject);
begin
  Show_back := not Show_back;
  Clear();
end;

procedure TForm1.S_rastrClick(Sender: TObject);//Сохранить растр

var
  f_name:string = '';

begin
  SaveDialog1.Filter:='Растровое изображение | *.png';
  SaveDialog1.FileName:='';

   If SaveDialog1.Execute then
       f_name:=SaveDialog1.FileName;

  If f_name<>'' then
  begin
        save_png:=TPortableNetworkGraphic.Create;
        save_png.Height:=WS.Height;
        save_png.Width:=WS.Width;

        //save_png.Canvas.CopyRect(Rect(0,0,WS.Width,WS.Height),WS.Canvas,
        //                                           Rect(0,0,WS.Width,WS.Height));

        //Подготовка изображения
        prepare_pic(save_png);

        save_png.SaveToFile(f_name);
        save_png.Free;
  end;
end;

procedure SaveVector;//Сохранить вектор
begin
  with Form1 do
  begin
      SaveDialog1.Filter:='Векторное изображение | *.vp';
      SaveDialog1.FileName:='';

      If f_name='' then
      If SaveDialog1.Execute then
           f_name:=SaveDialog1.FileName;
      if f_name<>'' then
      begin
          Save_vect(f_name);
          Save_as_menu.Enabled := true;

          NeedSave := false;
      end;
  end;
end;

procedure TForm1.Start_timer_delayTimer(Sender : TObject);
begin
  Clear;
  Start_timer_delay.Enabled:=false;
end;

procedure TForm1.S_vectorClick(Sender : TObject); //меню Сохранить вектор
begin
  SaveVector();
end;

procedure TForm1.ViborClick(Sender: TObject);//Меню выбора
begin
   if (NeedHelp) then
      ShowMessage('Если выбран не тот объект, то нажми ESC');

   Reset_mode;
   Select_mode := true;
   Selected := 10000;

   If Select_mode = true then
             Form1.StatusBar1.Panels.Items[0].Text:='Выбери объект'
   Else Form1.StatusBar1.Panels.Items[0].Text:='Ничего не выбрано';
end;

procedure TForm1.WSClick(Sender : TObject);
begin

end;




end.

