unit Unit5;

{
    Vector graphical editor.
    Version: 10.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2024  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

//Множественный выбор (выбрать все)

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm5 }

  TForm5 = class(TForm)
    Cancel_but: TButton;
    arc_sel : TCheckBox;
    DimSel : TCheckBox;
    Ok_but: TButton;
    c_sel: TCheckBox;
    p_sel: TCheckBox;
    t_sel: TCheckBox;
    L_sel: TCheckBox;
    arr_sel: TCheckBox;
    procedure Cancel_butClick(Sender: TObject);
    procedure Ok_butClick(Sender: TObject);
  private

  public

  end;

var
  Form5: TForm5;

implementation
uses Unit1;

{$R *.lfm}

{ TForm5 }

procedure TForm5.Cancel_butClick(Sender: TObject);//Отмена
begin
  Self.ModalResult:=mrCancel;
end;

procedure TForm5.Ok_butClick(Sender: TObject);

var
  count : integer;

begin
  //Проверка выбора линий
  If (L_sel.Checked) then
  for count := 0 to High(lines) do
    begin
             setLength(multy_selected_line,Length(multy_selected_line)+1);
             multy_selected_line[High(multy_selected_line)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;
             Form1.WS.Canvas.Line(Round(lines[count].x1 + Screen_x),
                                  Round(lines[count].y1 + Screen_y),
                                  Round(lines[count].x2 + Screen_x),
                                  Round(lines[count].y2 + Screen_y));
             SelAllMode := true;
    end;

   //Проверка выбора окружностей
   If (c_sel.Checked) then
   for count := 0 to High(circles) do
    begin
             setLength(multy_selected_circle,Length(multy_selected_circle)+1);
             multy_selected_circle[High(multy_selected_circle)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;
             Form1.WS.Canvas.Ellipse(Round(circles[count].x + Screen_x - circles[count].r),
                                     Round(circles[count].y + Screen_y - circles[count].r),
                                     Round(circles[count].x + Screen_x + circles[count].r),
                                     Round(circles[count].y + Screen_y + circles[count].r));
             SelAllMode := true;
    end;

    //Проверка выбора точек
    If (p_sel.Checked) then
    for count := 0 to High(points) do
    begin
             if (points[count].x = 0) and
                (points[count].y = 0) then continue;

             setLength(multy_selected_point,Length(multy_selected_point)+1);
             multy_selected_point[High(multy_selected_point)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;

             Form1.WS.Canvas.Ellipse(Round(points[count].x + Screen_x - 5),
                                     Round(points[count].y + Screen_y - 5),
                                     Round(points[count].x + Screen_x + 5),
                                     Round(points[count].y + Screen_y + 5));
             SelAllMode := true;
    end;

    //Проверка выбора текста
    If (t_sel.Checked) then
    for count := 0 to High(points) do
    begin
             setLength(multy_selected_text,Length(multy_selected_text)+1);
             multy_selected_text[High(multy_selected_text)] := count;
             Form1.WS.Canvas.Font.Color := clRed;
             Form1.WS.Canvas.Font.Size := Round(nadp[count].h);
             Form1.WS.Canvas.TextOut(Round(nadp[count].x + Screen_x), Round(nadp[count].y + Screen_y),nadp[count].s);

             SelAllMode := true;
    end;


    //Проверка выбора стрелок
    If (arr_sel.Checked) then
    for count := 0 to High(points) do
    begin
             setLength(multy_selected_arrow,Length(multy_selected_arrow)+1);
             multy_selected_arrow[High(multy_selected_arrow)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;

             Form1.WS.Canvas.Ellipse(Round(arrow[count].x + Screen_x -5),
                                     Round(arrow[count].y + Screen_y +5),
                                     Round(arrow[count].x + Screen_x +5),
                                     Round(arrow[count].y + + Screen_y -5));
             if arrow[count].t = 'left' then
                  Form1.WS.Canvas.Ellipse(Round(arrow[count].x+30-5+Screen_x),
                                          Round(arrow[count].y+5+Screen_y),
                                          Round(arrow[count].x+30+5+Screen_x),
                                          Round(arrow[count].y-5+Screen_y));
             if arrow[count].t = 'right' then
                  Form1.WS.Canvas.Ellipse(Round(arrow[count].x-30-5+Screen_x),
                                          Round(arrow[count].y+5+Screen_y),
                                          Round(arrow[count].x-30+5+Screen_x),
                                          Round(arrow[count].y-5+Screen_y));
             if arrow[count].t = 'up' then
                  Form1.WS.Canvas.Ellipse(Round(arrow[count].x-5+Screen_x),
                                          Round(arrow[count].y+30+5+Screen_y),
                                          Round(arrow[count].x+5+Screen_x),
                                          Round(arrow[count].y+30-5+Screen_y));
             if arrow[count].t = 'down' then
                  Form1.WS.Canvas.Ellipse(Round(arrow[count].x-5+Screen_x),
                                          Round(arrow[count].y-30+5+Screen_y),
                                          Round(arrow[count].x+5+Screen_x),
                                          Round(arrow[count].y-30-5+Screen_y));

             SelAllMode := true;
    end;

    //Проверка выбора дуги
    If (arc_sel.Checked) then
    for count := 0 to High(points) do
    begin
             setLength(multy_selected_arcs,Length(multy_selected_arcs)+1);
             multy_selected_arcs[High(multy_selected_arcs)] := count;
             Form1.WS.Canvas.Pen.Color := clRed;

             Form1.WS.canvas.Arc(Round(Arcs[count].l_x+Screen_x),
                                 Round(Arcs[count].t_y+Screen_y),
                                 Round(Arcs[count].r_x+Screen_x),
                                 Round(Arcs[count].b_y+Screen_y),
                                 Round(Arcs[count].x1+Screen_x),
                                 Round(Arcs[count].y1+Screen_y),
                                 Round(Arcs[count].x2+Screen_x),
                                 Round(Arcs[count].y2+Screen_y));

             SelAllMode := true;
    end;


    //Проверка выбора размеров
    If (DimSel.Checked) then
    for count := 0 to High(DimAr) do
      begin
               setLength(multy_selected_dim,Length(multy_selected_dim)+1);
               multy_selected_dim[High(multy_selected_dim)] := count;

               Form1.WS.Canvas.Pen.Color := clRed;
               Form1.WS.Canvas.Pen.Color := clRed;
               Form1.WS.Canvas.Ellipse(Round(DimAr[count].x3-5+Screen_x), Round(DimAr[count].y3-5+Screen_y),
                                       Round(DimAr[count].x3+5+Screen_x), Round(DimAr[count].y3+5+Screen_y));
               Form1.WS.Canvas.Ellipse(Round(DimAr[count].x4-5+Screen_x), Round(DimAr[count].y4-5+Screen_y),
                                       Round(DimAr[count].x4+5+Screen_x), Round(DimAr[count].y4+5+Screen_y));

               Form1.WS.Canvas.Ellipse(Round(DimAr[count].x1-5+Screen_x), Round(DimAr[count].y1-5+Screen_y),
                                       Round(DimAr[count].x1+5+Screen_x), Round(DimAr[count].y1+5+Screen_y));
               Form1.WS.Canvas.Ellipse(Round(DimAr[count].x2-5+Screen_x), Round(DimAr[count].y2-5+Screen_y),
                                       Round(DimAr[count].x2+5+Screen_x), Round(DimAr[count].y2+5+Screen_y));

               SelAllMode := true;
      end;

      Self.ModalResult:=mrCancel;
end;

end.

