unit Unit6;

{
    Vector graphical editor.
    Version: 10.
    Written on FreePascal (https://freepascal.org/).
    Copyright (C) 2024  Warfalomay

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <https://www.gnu.org/licenses/>.
}

//Пострроение отрезка по углу и длине

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm6 }

  TForm6 = class(TForm)
    Ok_button: TButton;
    Cancel_button: TButton;
    Ugol: TEdit;
    Dlina: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure Ok_buttonClick(Sender: TObject);
    procedure Cancel_buttonClick(Sender: TObject);
    procedure DlinaKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form6: TForm6;

implementation
Uses Unit1, Intersection_unit, my_modify, view, block;
{$R *.lfm}

{ TForm6 }

var
  x1,y1,x2,y2:double;
  angle:double;
  l:double;

procedure TForm6.Cancel_buttonClick(Sender: TObject);
begin
  //Отмена операции
  Unit1.stad:=false;
  Unit1.d_length:=0;

  Delete(lines,k,1);
  SetLength(lines,arr_length);

  Self.ModalResult:=mrCancel;
end;

//Оставлена возможность через If для других объектов
procedure dobav_lin();
begin
  If ((Unit1.stad=true) or
     (contin_line) and (last_point.X<>-1) and (last_point.Y<>-1))
     and (StrToFloat(Form6.Dlina.Text)>0) then //Построение линии
  begin
     angle:=StrToFloat(Form6.Ugol.Text)*PI/180;
     l:=StrToFloat(Form6.Dlina.Text);

     x2:=x1+(l*cos(angle));
     y2:=y1-(l*sin(angle));

      if (contin_line) and
         (last_point.X<>-1) and
         (last_point.Y<>-1) then
           begin
              //save_prev(); //Сохранить предыдущее состояние

              lines[k].x1:=last_point.X;
              lines[k].y1:=last_point.Y;
              stad:=true;

              x2:=last_point.X+(l*cos(angle));
              y2:=last_point.Y-(l*sin(angle));
           end;


     Unit1.lines[k].x2:=x2;
     Unit1.lines[k].y2:=y2;
     Unit1.lines[k].col:=Unit1.Cvet;
     Unit1.lines[k].id := id;
     id += 1;

     last_point.X := x2;
     last_point.Y := y2;

     If Form1.Need_intersect_point.Checked then
     begin
         //проверка пересечения линий
          prov_intersect();
          //проверка пересечения с окружностью
          intersection_line_circ(k);
     end;

     k+=1;

     Form6.ModalResult:=mrCancel;
  end;
end;

//Построение прямоугольника по заданным размерам
procedure dobav_rect();
begin
  //1 отрезок

    save_prev(); //Сохранить предыдущее состояние

    lines[k].x1:=x_rect;
    lines[k].y1:=y_rect;
    lines[k].x2:=x_rect+StrToFloat(Form6.Dlina.Text);
    lines[k].y2:=y_rect;
    lines[k].col:=Cvet;
    lines[k].Width:=LineWeight;
    lines[k].style:=LineStyle;
    lines[k].id := id;
    id += 1;

    //проверка пересечения линий
    prov_intersect();
    //проверка пересечения с окружностью
    intersection_line_circ(k);
    k+=1;

  //2 отрезок
    lines[k].x1:=x_rect+StrToFloat(Form6.Dlina.Text);
    lines[k].y1:=y_rect;
    lines[k].x2:=x_rect+StrToFloat(Form6.Dlina.Text);
    lines[k].y2:=y_rect+StrToFloat(Form6.Ugol.Text);
    lines[k].col:=Cvet;
    lines[k].Width:=LineWeight;
    lines[k].style:=LineStyle;
    lines[k].id := id;
    id += 1;

    //проверка пересечения линий
    prov_intersect();
    //проверка пересечения с окружностью
    intersection_line_circ(k);
    k+=1;

  //3 отрезок
    lines[k].x1:=x_rect+StrToFloat(Form6.Dlina.Text);
    lines[k].y1:=y_rect+StrToFloat(Form6.Ugol.Text);
    lines[k].x2:=x_rect;
    lines[k].y2:=y_rect+StrToFloat(Form6.Ugol.Text);
    lines[k].col:=Cvet;
    lines[k].Width:=LineWeight;
    lines[k].style:=LineStyle;
    lines[k].id := id;
    id += 1;

    //проверка пересечения линий
    prov_intersect();
    //проверка пересечения с окружностью
    intersection_line_circ(k);
    k+=1;

  //4 отрезок
    lines[k].x1:=x_rect;
    lines[k].y1:=y_rect+StrToFloat(Form6.Ugol.Text);
    lines[k].x2:=x_rect;
    lines[k].y2:=y_rect;
    lines[k].col:=Cvet;
    lines[k].Width:=LineWeight;
    lines[k].style:=LineStyle;
    lines[k].id := id;
    id += 1;

    //проверка пересечения линий
    prov_intersect();
    //проверка пересечения с окружностью
    intersection_line_circ(k);
    k+=1;

    SetLength(multy_selected_line,4);
    multy_selected_line[0] := k - 4;
    multy_selected_line[1] := k - 3;
    multy_selected_line[2] := k - 2;
    multy_selected_line[3] := k - 1;
    MakeBlock;
    SetLength(multy_selected_line,0);

    stad:=false;

    Clear();//Очистка формы

    Form1.StatusBar1.Panels.Items[0].Text:='Укажи первую точку';
    Form6.ModalResult:=mrCancel;
end;

procedure TForm6.DlinaKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  If (Key=ord(13)) and (Unit1.stad=true) then
  If draw_line_mode then
     dobav_lin()
  else
     dobav_rect();
end;

procedure TForm6.FormShow(Sender: TObject);
begin
     if draw_line_mode then
     begin
         x1:=Unit1.lines[k].x1;
         y1:=Unit1.lines[k].y1;
         If Dlina.Text<>'' then
            l:=StrToFloat(Dlina.Text);

         //Ugol.Text:=FloatToStr(Angle*180/pi);

         Dlina.SetFocus;
         Dlina.SelStart:=2;
     end;
     if draw_rectangle_mode then
     begin
         Ugol.Text:='';
         Dlina.Text:='';
         Dlina.SetFocus;
         Dlina.SelStart:=2;
     end;
end;

procedure TForm6.Ok_buttonClick(Sender: TObject);
begin
  if draw_line_mode then
     dobav_lin();
  if draw_Rectangle_mode then
     dobav_rect();
end;

end.

